<?php
    class Category extends Controller{
		
        
        public function add()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/

            
            //start Add Anew Data
			if(isset($_POST['add']))
            {
                
                // preparing validation array
                $validationArray = array(
                                            "name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['enName'])->clear(),
                                                             "errorName"=>"category Name",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "ar_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['arName'])->clear(),
                                                             "errorName"=>"اسم القسم",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "sub"=>array(
                                                             "value"=>$this->loadSecurity($_POST['sub'])->clear(),
                                                             "errorName"=>"Sub Category",
                                                             "rules"=>"number"
                                                          ),
                                            "description"=>array(
                                                             "value"=>$this->loadSecurity($_POST['en_description'])->clear(),
                                                             "errorName"=>"category Description",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "ar_description"=>array(
                                                             "value"=>$this->loadSecurity($_POST['ar_description'])->clear(),
                                                             "errorName"=>"وصف القسم",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "keywords"=>array(
                                                             "value"=>$this->loadSecurity($_POST['en_keywords'])->clear(),
                                                             "errorName"=>"category keywords",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "ar_keywords"=>array(
                                                             "value"=>$this->loadSecurity($_POST['ar_keywords'])->clear(),
                                                             "errorName"=>"الكلمات الدليلية",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "status"=>array(
                                                             "value"=>$this->loadSecurity($_POST['status'])->clear(),
                                                             "errorName"=>"Status",
                                                             "rules"=>"number"
                                                          ),
                                  );
                // load validation classs and pass validation data
                $dataValid = $this->loadValidation($validationArray)->formValidate();
                // check if the data is ok
                if(is_array($dataValid) && array_key_exists("success",$dataValid))
                {

                    // start upload image
                    $upload = $this->loadUpload("image")->do_upload();
                    
                    //if there is no errors
                    if (!array_key_exists('uploadError', $upload)) 
                    {
                    	//upload advertising image
						$advertisngImage=$this->loadUpload("advertisingimage")->do_upload();
                       // prepare data
                        $dataModel['created_by'] = $user_id;
                        $dataModel['last_update_by'] = $user_id;
                        $dataModel['status'] = $dataValid['success']['status'];
                        $dataModel['image'] = $upload['uploaded'][0];
						$dataModel['adv_image'] =  isset($advertisngImage['uploaded'][0])?$advertisngImage['uploaded'][0]:null;
                        $dataModel['created'] = time();
                        // check subcategory
                        if($dataValid['success']['sub'] == 1)
                        {
                            $dataModel['id_category'] = $this->loadSecurity($_POST['main_category'])->clear();
                        }
                        $add = $this->loadModel("CategoryModel",$dataModel)->add();
                        if(FALSE !== $add)
                        {
                        	// sart add multiple category images
							$categeryimages = $this->loadUpload("catmultipleimages",FALSE)->do_upload();
							// check if there is error on image
							if(!array_key_exists("uploadError",$categeryimages))
							{
								if($categeryimages['uploaded'][0] != NULL)
								{
									foreach($categeryimages['uploaded'] as $value)
									{
										$imagesdata['id_category'] = $add;
										$imagesdata['image'] = $value;
										$imagesdata['created'] = time();
										$imagesdata['created_by'] = $user_id;
										$imagesdata['last_updated_by'] = $user_id;
										// load Model To Add category images
										$addimages = $this->loadModel("CategoryImagesModel",$imagesdata)->add();
									}

								}
							}

                            // add data to report
                            $repoatDataModel['id_category'] = $add;
                            $repoatDataModel['created'] = time();
                            $addReport = $this->loadModel("CategoryReportModel",$repoatDataModel)->add();
                            // preparing en data
                            $dataEnModel['id_category'] = $add;
                            $dataEnModel['name'] = $dataValid['success']['name'];
                            $dataEnModel['description'] = $dataValid['success']['description'];
                            $dataEnModel['keywords'] = $dataValid['success']['keywords'];
                            $addEnData = $this->loadModel("CategoryEnModel",$dataEnModel)->add();


                            // preparing ar data
                            $dataArModel['id_category'] = $add;
                            $dataArModel['name'] = $dataValid['success']['ar_name'];
                            $dataArModel['description'] = $dataValid['success']['ar_description'];
                            $dataArModel['keywords'] = $dataValid['success']['ar_keywords'];

                            $addArData = $this->loadModel("CategoryArModel",$dataArModel)->add();
                            if(False !== $addEnData && FALSE !== $addArData)
                            {
                               $dataView['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Added Successfully Please Wait .. </div>';
                               header("Refresh: 2");
                            }else{
                                $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Adding Your Data Please Try Again</div>';
                            }
                        }else{
                            $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Adding Your Data Please Try Again</div>';
                        } 
                    }else{
                        $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Category Image Is Required (Max Image Size 2MB)</div>';
                    }
                    
                }else{
                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                }
            }
            // get all catgories
            
            $dataView['categories'] = $this->loadModel("CategoryModel")->retrieveAllData("WHERE `deleted` =?",array(1));
            if(is_array($dataView['categories']))
            {
                foreach($dataView['categories'] as $key=>$value)
                {
                    // get ar and en Data
                    $dataView['categoriesEn'][$key] = $this->loadModel("CategoryEnModel")->retriveDataById("id_category",$value['id']);
                    $dataView['categoriesAr'][$key] = $this->loadModel("CategoryArModel")->retriveDataById("id_category",$value['id']);
                }
            }
			$dataView['title'] = "Add Category";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."category_add";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
        public function getAll()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            
            // get all catgories
            
            $dataView['categories'] = $this->loadModel("CategoryModel")->retrieveAllData("WHERE `deleted` =?",array(1));
            if(is_array($dataView['categories']))
            {
                foreach($dataView['categories'] as $key=>$value)
                {
                    // get ar and en Data
                    $dataView['categoriesEn'][$key] = $this->loadModel("CategoryEnModel")->retriveDataById("id_category",$value['id']);
                    $dataView['categoriesAr'][$key] = $this->loadModel("CategoryArModel")->retriveDataById("id_category",$value['id']);
                }
            }
            
			$dataView['title'] = "Show / Edit category";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."category_getall";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
        public function edit_selected()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            // get id from url
            $id = (int)$this->loadRoute()->getSegment(2);
            if($id == 0)
            {
                $this->redirect("Errors","index");
                exit();
            }
            // get data
            $dataView['category'] = $this->loadModel("CategoryModel")->retrieveAllData("WHERE `id` =? AND `deleted` =?",array($id,1));
            if($dataView['category'] == NULL)
            {
                $this->redirect("Errors","index");
                exit();
            }
            $dataView['category'] = array_shift($dataView['category']);
             // get ar and en Data
            $dataView['categoryEn'] = $this->loadModel("CategoryEnModel")->retriveDataById("id_category",$id);
            $dataView['categoryAr'] = $this->loadModel("CategoryArModel")->retriveDataById("id_category",$id);

            //start Edit category
			if(isset($_POST['edit']))
            {
                
                // preparing validation array
                $validationArray = array(
                                            "name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['enName'])->clear(),
                                                             "errorName"=>"category Name",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "ar_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['arName'])->clear(),
                                                             "errorName"=>"اسم القسم",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "sub"=>array(
                                                             "value"=>$this->loadSecurity($_POST['sub'])->clear(),
                                                             "errorName"=>"Sub Category",
                                                             "rules"=>"number"
                                                          ),
                                            "description"=>array(
                                                             "value"=>$this->loadSecurity($_POST['en_description'])->clear(),
                                                             "errorName"=>"category Description",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "ar_description"=>array(
                                                             "value"=>$this->loadSecurity($_POST['ar_description'])->clear(),
                                                             "errorName"=>"وصف القسم",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "keywords"=>array(
                                                             "value"=>$this->loadSecurity($_POST['en_keywords'])->clear(),
                                                             "errorName"=>"category keywords",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "ar_keywords"=>array(
                                                             "value"=>$this->loadSecurity($_POST['ar_keywords'])->clear(),
                                                             "errorName"=>"الكلمات الدليلية",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "status"=>array(
                                                             "value"=>$this->loadSecurity($_POST['status'])->clear(),
                                                             "errorName"=>"Status",
                                                             "rules"=>"number"
                                                          ),
                                        
                                  );
                // load validation classs and pass validation data
                $dataValid = $this->loadValidation($validationArray)->formValidate();
                // check if the data is ok
                if(is_array($dataValid) && array_key_exists("success",$dataValid))
                {
                    // prepare data
                    $dataModel['last_update_by'] = $user_id;
                    $dataModel['status'] = $dataValid['success']['status'];
                    // check subcategory
                    if($dataValid['success']['sub'] == 1)
                    {
                        $dataModel['id_category'] = $this->loadSecurity($_POST['main_category'])->clear();
                    }else{
                        $dataModel['id_category'] = NULL;
                    }
                    $updateData = $this->loadModel("CategoryModel",$dataModel)->UpdateData("id",$id);
                    if(FALSE !== $updateData)
                    {
						// sart add multiple category images
						$categeryimages = $this->loadUpload("catmultipleimages",FALSE)->do_upload();
						// check if there is error on image
						if(!array_key_exists("uploadError",$categeryimages))
						{
							if($categeryimages['uploaded'][0] != NULL)
							{
								foreach($categeryimages['uploaded'] as $value)
								{
									$imagesdata['id_category'] = $id;
									$imagesdata['image'] = $value;
									$imagesdata['created'] = time();
									$imagesdata['created_by'] = $user_id;
									$imagesdata['last_updated_by'] = $user_id;
									// load Model To Add category images
									$addimages = $this->loadModel("CategoryImagesModel",$imagesdata)->add();
								}

							}
						}

						// preparing en data
                        $dataEnModel['name'] = $dataValid['success']['name'];
                        $dataEnModel['keywords'] = $dataValid['success']['keywords'];
                        $dataEnModel['description'] = $dataValid['success']['description'];
                        $updateEnData = $this->loadModel("CategoryEnModel",$dataEnModel)->UpdateData("id_category",$id);
                        // preparing ar data
                        $dataArModel['name'] = $dataValid['success']['ar_name'];
                        $dataArModel['description'] = $dataValid['success']['ar_description'];
                        $dataArModel['keywords'] = $dataValid['success']['ar_keywords'];                        $updateArData = $this->loadModel("CategoryArModel",$dataArModel)->UpdateData("id_category",$id);
                        // update report
                        $reportModel['status'] = $dataValid['success']['status'];
                        $this->loadModel("CategoryReportModel",$reportModel)->updateData("id_category", $id);
                        if(False !== $updateEnData && FALSE !== $updateArData)
                        {
                           $dataView['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Updated Successfully Please Wait .. </div>';
                           header("Refresh: 2"); 
                        }else{
                            $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Updating Your Data Please Try Again</div>';
                        }
                    }else{
                        $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Updating Your Data Please Try Again</div>';
                    } 
                    
                }else{
                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                }
            }
            
            // get all catgories
            
            $dataView['categories'] = $this->loadModel("CategoryModel")->retrieveAllData("WHERE `deleted` =?",array(1));
            if(is_array($dataView['categories']))
            {
                foreach($dataView['categories'] as $key=>$value)
                {
                    // get ar and en Data
                    $dataView['categoriesEn'][$key] = $this->loadModel("CategoryEnModel")->retriveDataById("id_category",$value['id']);
                    $dataView['categoriesAr'][$key] = $this->loadModel("CategoryArModel")->retriveDataById("id_category",$value['id']);
                }
            }
			$dataView['title'] = "Edit Selected category";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."category_edit_selected";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        public function edit_attributes()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            // get id from url
            $id = (int)$this->loadRoute()->getSegment(2);
            if($id == 0)
            {
                $this->redirect("Errors","index");
                exit();
            }
            // get data
            $dataView['category'] = $this->loadModel("CategoryModel")->retrieveAllData("WHERE `id` =? AND `deleted` =?",array($id,1));
            if($dataView['category'] == NULL)
            {
                $this->redirect("Errors","index");
                exit();
            }
            $dataView['category'] = array_shift($dataView['category']);
             // get ar and en Data
            $dataView['categoryEn'] = $this->loadModel("CategoryEnModel")->retriveDataById("id_category",$id);
            $dataView['categoryAr'] = $this->loadModel("CategoryArModel")->retriveDataById("id_category",$id);

            //start add attributes
			if(isset($_POST['add']))
            {
                if(isset($_POST['en_attribute']) && is_array($_POST['en_attribute']))
                {
                    $enAttribute = $_POST['en_attribute'];
                    $arAttribute = $_POST['ar_attribute'];
                    $counter = 0;
                    foreach($enAttribute as $key=>$value)
                    {
                        // check data is not empty
                        if($value != NULL && $arAttribute[$key] != NULL)
                        {
                            // preparing data model
                            $dataModel['admin_id'] = $user_id;
                            $dataModel['id_category'] = $id;
                            $dataModel['created'] = time();
                            // add data
                            $add = $this->loadModel("CategoryAttributesModel",$dataModel)->add();
                            if(FALSE !== $add)
                            {
                                //preparing en data model
                                $dataModelEn['id_category_attributes'] = $add;
                                $dataModelEn['name'] = $value;
                                $addEnData = $this->loadModel("CategoryAttributesEnModel",$dataModelEn)->add();
                                //preparing ar data model
                                $dataModelAr['id_category_attributes'] = $add;
                                $dataModelAr['name'] = $arAttribute[$key];
                                $addArData = $this->loadModel("CategoryAttributesArModel",$dataModelAr)->add();
                                $counter++;
                            }
                        }
                    }
                    
                    if($counter == 0)
                    {
                        $dataView['message'] = '<div class="alert alert-warning" role="alert"><staong><i class="fa fa-exclamation-triangle" aria-hidden="true"></i> Warinig ! </strong>No Data Added (Please Add English And Arabic Data)</div>';
                    }else if($counter < count($_POST['en_attribute'])){
                        $dataView['message'] = '<div class="alert alert-warning" role="alert"><staong>
                                                <i class="fa fa-exclamation-triangle" aria-hidden="true"></i> Warning !
                                                </strong>
                                                Some Data Not Added May Be Because Of One Of Those Reasons 
                                                <br />
                                                1 - You Left Some Data Empty
                                                <br />
                                                2 - You Add English Data And Left Arabic data
                                                </div>';
                    }else{
                        $dataView['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong>Your Data Added Successfully Please Wait ..</div>';
                        header("Refresh: 2");
                    }
                }else{
                     $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> You Did Not Add Any Attribute</div>';
                }
                
            }
            
            // get all catgory attribute
            
            $dataView['attributes'] = $this->loadModel("CategoryAttributesModel")->retrieveAllData("WHERE `id_category` =? AND `deleted` =?",array($id,1));
            if(is_array($dataView['attributes']))
            {
                foreach($dataView['attributes'] as $key=>$value)
                {
                    // get ar and en Data
                    $dataView['attributesEn'][$key] = $this->loadModel("CategoryAttributesEnModel")->retriveDataById("id_category_attributes",$value['id']);
                    $dataView['attributesAr'][$key] = $this->loadModel("CategoryAttributesArModel")->retriveDataById("id_category_attributes",$value['id']);
                }
            }
            
			$dataView['title'] = "Edit category Attributes";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."category_edit_attributes";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
		public function categoryImages()
		{
			/******** start header code ********/
			if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
			{
				// get user id from session
				$user_id = $this->loadSession()->getSession("user_id");
				// get user data for header
				$dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
				if($dataView['userData'] == NULL)
				{
					$this->redirect("Errors","index");
					exit();
				}
			}else{
				$this->redirect("admin","login");
			}

			/******* end header code *******/
			// get id from url
			$id = (int)$this->loadRoute()->getSegment(2);
			if($id == 0)
			{
				$this->redirect("Errors","index");
				exit();
			}
			// get data
			$dataView['category'] = $this->loadModel("CategoryModel")->retrieveAllData("WHERE `id` =? AND `deleted` =?",array($id,1));
			if($dataView['category'] == NULL)
			{
				$this->redirect("Errors","index");
				exit();
			}
			$dataView['category'] = array_shift($dataView['category']);
			// get ar and en Data
			//get category images
			$dataView['images']=$this->loadModel("CategoryImagesModel")->retrieveAllData("WHERE `id_category`=? AND `deleted` =?",array($id,1));
			$dataView['title'] = "Show Category Images";
			// global Template Config
			global $TEMPLATE_BACK_END ;
			// set content
			$TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."category_images";
			// load template
			$this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
		}
        public function update_image()
        {
                //get id
                $id = (int)$_POST['field_id'];
                 if($id == 0)
                {
                    echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                    exit;
                }else{
                        $upload = $this->loadUpload("image_name")->do_upload();
                       // check if there is error on image
                       if(array_key_exists("uploadError",$upload))
                       {
                           echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                            exit;

                       }else{
                           $dataModel['image'] = $upload['uploaded'][0];
                           // get user id from session
                           $user_id = $this->loadSession()->getSession("user_id");
                           $dataModel['last_update_by'] = $user_id;
                           if(false !== $this->loadModel("CategoryModel",$dataModel)->updateData("id", $id))
                           {
                               echo $this->loadAjax()->DataToJson(array("status"=>"success","newImage"=>$dataModel['image']));
                                exit; 
                           }else{
                              echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                            exit;
                           }
                       }
                    }  
        }
		public function update_adv_image()
		{
			//get id
			$id = (int)$_POST['field_id'];
			if($id == 0)
			{
				echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
				exit;
			}else{
				$upload = $this->loadUpload("image_name")->do_upload();
				// check if there is error on image
				if(array_key_exists("uploadError",$upload))
				{
					echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
					exit;

				}else{
					$dataModel['adv_image'] = $upload['uploaded'][0];
					//$dataModel['last_updated_by'] = $this->loadSession()->getSession("user_id");
					if(false !== $this->loadModel("CategoryModel",$dataModel)->updateData("id", $id))
					{
						echo $this->loadAjax()->DataToJson(array("status"=>"success","newImage"=>$dataModel['adv_image']));
						exit;
					}else{
						echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
						exit;
					}
				}
			}
		}
        public function updateStatus()
        {
                if(isset($_POST['action'],$_POST['id'],$_POST['status']) && $_POST['action'] == "updateStatus")
                {
                    // get User id
                    $id = (int)$_POST['id'];
                    if($id == 0)
                    {
                        $this->redirect("Errors","index");
                        exit;
                    }else{
                        // get current status
                        $currentStatus = $_POST['status'];
                        // if current status = on set it off
                        if($currentStatus == "on")
                        {
                            $setStatus = 2;
                        }else{
                            $setStatus = 1;
                        }
                        $dataModel['status'] = $setStatus;
                        // get user id from session
                        $user_id = $this->loadSession()->getSession("user_id");
                        $dataModel['last_update_by'] = $user_id;
                        if(false !== $this->loadModel("CategoryModel",$dataModel)->updateData("id", $id))
                        {
                            $this->loadModel("CategoryReportModel",$dataModel)->updateData("id_category", $id);
                         echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                         exit;
                        }else{
                            echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                            exit;
                        }
                    }
                }
         }
        public function updateArrtibutesStatus()
        {
                if(isset($_POST['action'],$_POST['id'],$_POST['status']) && $_POST['action'] == "updateStatus")
                {
                    // get User id
                    $id = (int)$_POST['id'];
                    if($id == 0)
                    {
                        $this->redirect("Errors","index");
                        exit;
                    }else{
                        // get current status
                        $currentStatus = $_POST['status'];
                        // if current status = on set it off
                        if($currentStatus == "on")
                        {
                            $setStatus = 2;
                        }else{
                            $setStatus = 1;
                        }
                        $dataModel['status'] = $setStatus;

                        if(false !== $this->loadModel("CategoryAttributesModel",$dataModel)->updateData("id", $id))
                        {
                         echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                         exit;
                        }else{
                            echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                            exit;
                        }
                    }
                }
         }
        public function delete()
        {
                if(isset($_POST['action'],$_POST['id']) && $_POST['action'] == "deleteData")
                {
                    $id = (int)$_POST['id'];
                    if($id == 0)
                    {
                        $this->redirect("Errors","index");
                        exit;
                    }else{
                        // get user id from session
                        $user_id = $this->loadSession()->getSession("user_id");
                        $dataModel['last_update_by'] = $user_id;
                        $dataModel['deleted'] = 2;
                        if(FALSE !== $this->loadModel("CategoryModel",$dataModel)->updateData("id",$id))
                        {
                            $this->loadModel("CategoryReportModel",array("deleted"=>2))->updateData("id_category",$id);
                            echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                            exit;
                        }else{
                            echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                            exit;
                        }
                    }
                 }
         }
         public function delete_category_images()
		 {
			 if(isset($_POST['action'],$_POST['imageId']) && $_POST['action'] == "deleteImage")
			 {
				 $id = (int)$_POST['imageId'];
				 if($id == 0)
				 {
					 $this->redirect("Errors","index");
					 exit;
				 }else{
					 // get user id from session
					 $user_id = $this->loadSession()->getSession("user_id");
					 $dataModel['last_updated_by'] = $user_id;
					 $dataModel['deleted'] = 2;
					 if(FALSE !== $this->loadModel("CategoryImagesModel",$dataModel)->updateData("id",$id))
					 {
						 echo $this->loadAjax()->DataToJson(array("status"=>"success"));
						 exit;
					 }else{
						 echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
						 exit;
					 }
				 }
			 }

		 }
        public function deleteAttributes()
        {
                if(isset($_POST['action'],$_POST['id']) && $_POST['action'] == "deleteData")
                {
                    $id = (int)$_POST['id'];
                    if($id == 0)
                    {
                        $this->redirect("Errors","index");
                        exit;
                    }else{
                        if(FALSE !== $this->loadModel("CategoryAttributesModel",array("deleted"=>2))->updateData("id",$id))
                        {
                            echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                            exit;
                        }else{
                            echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                            exit;
                        }
                    }
                 }
         }
        
    }

?>