<?php
    class Country extends Controller{
		
        
        public function add()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            
            
            //start Add Anew Country
			if(isset($_POST['add']))
            {
                // preparing validation array
                $validationArray = array(
                                            "name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['name'])->clear(),
                                                             "errorName"=>"Country Name",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "shortcut_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['shortcut_name'])->clear(),
                                                             "errorName"=>"Shortcut Name",
                                                             "rules"=>"required|min-length[1]"
                                                          ),
                                            "currency_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['currency'])->clear(),
                                                             "errorName"=>"Country Currency",
                                                             "rules"=>"required|min-length[2]"
                                                          ),
                                            "currency_shortcut_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['shortcut_currency'])->clear(),
                                                             "errorName"=>"Country Currency Shortcut",
                                                             "rules"=>"required|min-length[1]"
                                                          ),
                                            
                                            "phone_key"=>array(
                                                             "value"=>$this->loadSecurity($_POST['phone_key'])->clear(),
                                                             "errorName"=>"Country Currency Phone Key",
                                                             "rules"=>"required|min-length[1]"
                                                          ),
                                            "longitude"=>array(
                                                             "value"=>$this->loadSecurity($_POST['long'])->clear(),
                                                             "errorName"=>"Country Longitude",
                                                             "rules"=>"required"
                                                          ),
                                            "latitude"=>array(
                                                             "value"=>$this->loadSecurity($_POST['lat'])->clear(),
                                                             "errorName"=>"Country Latitude",
                                                             "rules"=>"required"
                                                          ),
                                            "ar_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['ar_name'])->clear(),
                                                             "errorName"=>"أسم الدولة",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "ar_shortcut_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['ar_shortcut_name'])->clear(),
                                                             "errorName"=>"مختصر الاسم",
                                                             "rules"=>"required|min-length[1]"
                                                          ),
                                            "ar_currency_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['ar_currency'])->clear(),
                                                             "errorName"=>"اسم العملة",
                                                             "rules"=>"required|min-length[2]"
                                                          ),
                                            "ar_currency_shortcut_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['ar_shortcut_currency'])->clear(),
                                                             "errorName"=>"مختصر العملة",
                                                             "rules"=>"required|min-length[1]"
                                                          ),
                                            "status"=>array(
                                                             "value"=>$this->loadSecurity($_POST['status'])->clear(),
                                                             "errorName"=>"Status",
                                                             "rules"=>"number"
                                                          ),
                                  );
                // load validation classs and pass validation data
                $dataValid = $this->loadValidation($validationArray)->formValidate();
                // check if the data is ok
                if(is_array($dataValid) && array_key_exists("success",$dataValid))
                {
                    //check if country En  Name exists before
                    if(TRUE !== $this->loadModel("CountryEnModel")->CheckExists("WHERE `name` =? AND `deleted`=?",array($dataValid['success']['name'],1)))
                    {
                        //check if country Ar  Name exists before
                        if(TRUE !== $this->loadModel("CountryArModel")->CheckExists("WHERE `name` =? AND `deleted`=?",array($dataValid['success']['ar_name'],1)))
                        {
                            // start upload image
                            $upload = $this->loadUpload("image")->do_upload();

                            //if there is no errors
                            if (!array_key_exists('uploadError', $upload)) 
                            {
                                // prepare data
                                $dataModel['phone_key'] = $dataValid['success']['phone_key'];
                                $dataModel['longitude'] = $dataValid['success']['longitude'];
                                $dataModel['latitude'] = $dataValid['success']['latitude'];
                                $dataModel['flag'] = $upload['uploaded'][0];
                                $dataModel['created_by'] = $user_id;
                                $dataModel['createdAt'] = date('Y-m-d h:i:s');
                                $dataModel['last_updated_by'] = $user_id;
                                $dataModel['status'] = $dataValid['success']['status'];
                                $add = $this->loadModel("CountryModel",$dataModel)->add();
                                if(FALSE !== $add)
                                {
                                    // preparing ar data
                                    $dataArModel['id_country'] = $add;
                                    $dataArModel['name'] = $dataValid['success']['ar_name'];
                                    $dataArModel['shortcut_name'] = $dataValid['success']['ar_shortcut_name'];
                                    $dataArModel['currency_name'] = $dataValid['success']['ar_currency_name'];
                                    $dataArModel['currency_shortcut_name'] = $dataValid['success']['ar_currency_shortcut_name'];
                                    $dataArModel['created_by'] = $user_id;
                                    $dataArModel['createdAt'] = date('Y-m-d h:i:s');
                                    $dataArModel['last_updated_by'] = $user_id;
                                    $dataArModel['status'] = $dataValid['success']['status'];
                                    $addArData = $this->loadModel("CountryArModel",$dataArModel)->add();
                                    
                                    // preparing  en data
                                    $dataEnModel['id_country'] = $add;
                                    $dataEnModel['name'] = $dataValid['success']['name'];
                                    $dataEnModel['shortcut_name'] = $dataValid['success']['shortcut_name'];
                                    $dataEnModel['currency_name'] = $dataValid['success']['currency_name'];
                                    $dataEnModel['currency_shortcut_name'] = $dataValid['success']['currency_shortcut_name'];
                                    $dataEnModel['created_by'] = $user_id;
                                    $dataEnModel['createdAt'] = date('Y-m-d h:i:s');
                                    $dataEnModel['last_updated_by'] = $user_id;
                                    $dataEnModel['status'] = $dataValid['success']['status'];
                                    $addEnData = $this->loadModel("CountryEnModel",$dataEnModel)->add();
                                    
                                    $dataView['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Added Successfully Please Wait .. </div>';
                                    header("Refresh: 2"); 
                                }else{
                                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Adding Your Data Please Try Again</div>';
                                }  
                            }else{
                                $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Country Flag Image Is Required (Max Image Size 2MB)</div>';
                            }
                        }else{
                            $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Country Arabic Name Exists Before</div>';
                        }
                    }else{
                        $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Country English Name Exists Before</div>';
                    }
                }else{
                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                }
            }
            
			$dataView['title'] = "Add Country";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "country" . DIRECTORY_SEPARATOR ."country_add";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
        public function getAll()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            
            // get all counteries
            $dataView['counteries'] = $this->loadModel("CountryModel")->retrieveAllData("WHERE `deleted` =?",array(1));
            if(is_array($dataView['counteries']))
            {
                foreach($dataView['counteries'] as $key=>$value)
                {
                    // get ar and en data
                    $dataView['counteriesEn'][$key] = $this->loadModel("CountryEnModel")->retriveDataById("id_country",$value['id']);
                    $dataView['counteriesAr'][$key] = $this->loadModel("CountryArModel")->retriveDataById("id_country",$value['id']);
                
                    // get last updated by and created by
                    $dataView['createdBy'][$key] = $this->loadModel("UserModel")->retriveDataById("id",$value['created_by']);
                    $dataView['lastUpdateBy'][$key] = $this->loadModel("UserModel")->retriveDataById("id",$value['last_updated_by']);
                }
            }
            
			$dataView['title'] = "Show / Edit Country";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "country" . DIRECTORY_SEPARATOR ."country_getall";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
        public function edit_selected()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            // get id from url
            $id = (int)$this->loadRoute()->getSegment(2);
            if($id == 0)
            {
                $this->redirect("Errors","index");
                exit();
            }
            // get data
            $dataView['country'] = $this->loadModel("CountryModel")->retrieveAllData("WHERE `id` =? AND `deleted` =?",array($id,1));
            if($dataView['country'] == NULL)
            {
                $this->redirect("Errors","index");
                exit();
            }
            $dataView['country'] = array_shift($dataView['country']);
             // get ar and en Data
            $dataView['countryEn'] = $this->loadModel("CountryEnModel")->retriveDataById("id_country",$id);
            $dataView['countryAr'] = $this->loadModel("CountryArModel")->retriveDataById("id_country",$id);

             // start edit country
			if(isset($_POST['edit']))
            {
                // preparing validation array
                // preparing validation array
                $validationArray = array(
                                            "name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['name'])->clear(),
                                                             "errorName"=>"Country Name",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "shortcut_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['shortcut_name'])->clear(),
                                                             "errorName"=>"Shortcut Name",
                                                             "rules"=>"required|min-length[1]"
                                                          ),
                                            "currency_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['currency'])->clear(),
                                                             "errorName"=>"Country Currency",
                                                             "rules"=>"required|min-length[2]"
                                                          ),
                                            "currency_shortcut_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['shortcut_currency'])->clear(),
                                                             "errorName"=>"Country Currency Shortcut",
                                                             "rules"=>"required|min-length[1]"
                                                          ),
                                            
                                            "phone_key"=>array(
                                                             "value"=>$this->loadSecurity($_POST['phone_key'])->clear(),
                                                             "errorName"=>"Country Currency Phone Key",
                                                             "rules"=>"required|min-length[1]"
                                                          ),
                                            "longitude"=>array(
                                                             "value"=>$this->loadSecurity($_POST['long'])->clear(),
                                                             "errorName"=>"Country Longitude",
                                                             "rules"=>"required"
                                                          ),
                                            "latitude"=>array(
                                                             "value"=>$this->loadSecurity($_POST['lat'])->clear(),
                                                             "errorName"=>"Country Latitude",
                                                             "rules"=>"required"
                                                          ),
                                            "ar_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['ar_name'])->clear(),
                                                             "errorName"=>"أسم الدولة",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "ar_shortcut_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['ar_shortcut_name'])->clear(),
                                                             "errorName"=>"مختصر الاسم",
                                                             "rules"=>"required|min-length[1]"
                                                          ),
                                            "ar_currency_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['ar_currency'])->clear(),
                                                             "errorName"=>"اسم العملة",
                                                             "rules"=>"required|min-length[2]"
                                                          ),
                                            "ar_currency_shortcut_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['ar_shortcut_currency'])->clear(),
                                                             "errorName"=>"مختصر العملة",
                                                             "rules"=>"required|min-length[1]"
                                                          ),
                                            "status"=>array(
                                                             "value"=>$this->loadSecurity($_POST['status'])->clear(),
                                                             "errorName"=>"Status",
                                                             "rules"=>"number"
                                                          ),
                                  );
                // load validation classs and pass validation data
                $dataValid = $this->loadValidation($validationArray)->formValidate();
                // check if the data is ok
                if(is_array($dataValid) && array_key_exists("success",$dataValid))
                {
                    //check if country En Name exists before
                    if(TRUE !== $this->loadModel("CountryEnModel")->CheckExists("WHERE `name` =? AND `id_country` != ? AND `deleted`=?",array($dataValid['success']['name'],$id,1)))
                    {
                        //check if country En Name exists before
                        if(TRUE !== $this->loadModel("CountryArModel")->CheckExists("WHERE `name` =? AND `id_country` != ? AND `deleted`=?",array($dataValid['success']['name'],$id,1)))
                        {
                            // prepare data
                            $dataModel['phone_key'] = $dataValid['success']['phone_key'];
                            $dataModel['longitude'] = $dataValid['success']['longitude'];
                            $dataModel['latitude'] = $dataValid['success']['latitude'];
                            $dataModel['last_updated_by'] = $user_id;
                            $dataModel['status'] = $dataValid['success']['status'];
                            $updateData = $this->loadModel("CountryModel",$dataModel)->updateData("id",$id);
                            if(FALSE !== $updateData)
                            {
                               // preparing ar data
                                $dataArModel['name'] = $dataValid['success']['ar_name'];
                                $dataArModel['shortcut_name'] = $dataValid['success']['ar_shortcut_name'];
                                $dataArModel['currency_name'] = $dataValid['success']['ar_currency_name'];
                                $dataArModel['currency_shortcut_name'] = $dataValid['success']['ar_currency_shortcut_name'];
                                $dataArModel['last_updated_by'] = $user_id;
                                $dataArModel['status'] = $dataValid['success']['status'];
                                $updateArData = $this->loadModel("CountryArModel",$dataArModel)->updateData("id_country",$id);

                                // preparing  en data
                                $dataEnModel['name'] = $dataValid['success']['name'];
                                $dataEnModel['shortcut_name'] = $dataValid['success']['shortcut_name'];
                                $dataEnModel['currency_name'] = $dataValid['success']['currency_name'];
                                $dataEnModel['currency_shortcut_name'] = $dataValid['success']['currency_shortcut_name'];
                                $dataEnModel['last_updated_by'] = $user_id;
                                $dataEnModel['status'] = $dataValid['success']['status'];
                                $updateEnData = $this->loadModel("CountryEnModel",$dataEnModel)->updateData("id_country",$id);
                                if(False !== $updateEnData && FALSE !== $updateArData)
                                {
                                   $dataView['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Updated Successfully Please Wait .. </div>';
                                   header("Refresh: 2"); 
                                }else{
                                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Updating Some Data Please Try Again</div>';
                                }
                            }else{
                                $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Updating Your Data Please Try Again</div>';
                            }
                        }else{
                            $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Country Arabic Name Exists Before</div>';
                        }
                    }else{
                        $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Country English Name Exists Before</div>';
                    }
                }else{
                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                }
            }
            
            // set page title
			$dataView['title'] = "Edit Selected Country";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "country" . DIRECTORY_SEPARATOR ."country_edit_selected";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        public function update_image()
        {
                //get id
                $id = (int)$_POST['field_id'];
                 if($id == 0)
                {
                    echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                    exit;
                }else{
                        $upload = $this->loadUpload("image_name")->do_upload();
                       // check if there is error on image
                       if(array_key_exists("uploadError",$upload))
                       {
                           echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                            exit;

                       }else{
                           $dataModel['flag'] = $upload['uploaded'][0];
                           if(false !== $this->loadModel("CountryModel",$dataModel)->updateData("id", $id))
                           {
                               echo $this->loadAjax()->DataToJson(array("status"=>"success","newImage"=>$dataModel['flag']));
                                exit; 
                           }else{
                              echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                            exit;
                           }
                       }
                    }  
        }
        public function updateStatus()
        {
                if(isset($_POST['action'],$_POST['id'],$_POST['status']) && $_POST['action'] == "updateStatus")
                {
                    // get User id
                    $id = (int)$_POST['id'];
                    if($id == 0)
                    {
                        $this->redirect("Errors","index");
                        exit;
                    }else{
                        // get current status
                        $currentStatus = $_POST['status'];
                        // if current status = on set it off
                        if($currentStatus == "on")
                        {
                            $setStatus = 2;
                        }else{
                            $setStatus = 1;
                        }
                        $dataModel['status'] = $setStatus;
                        $dataModel['last_updated_by'] = $this->loadSession()->getSession("user_id");

                        if(false !== $this->loadModel("CountryModel",$dataModel)->updateData("id", $id))
                        {
                             $this->loadModel("CountryArModel",$dataModel)->updateData("id_country", $id);
                             $this->loadModel("CountryEnModel",$dataModel)->updateData("id_country", $id);
                             echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                             exit;
                        }else{
                            echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                            exit;
                        }
                    }
                }
         }
        public function delete()
        {
                if(isset($_POST['action'],$_POST['id']) && $_POST['action'] == "deleteData")
                {
                    $id = (int)$_POST['id'];
                    if($id == 0)
                    {
                        $this->redirect("Errors","index");
                        exit;
                    }else{
                        // get user id from session
                        $last_updated_by = $this->loadSession()->getSession("user_id");
                        if(FALSE !== $this->loadModel("CountryModel",array("deleted"=>2,"last_updated_by"=>$last_updated_by))->updateData("id",$id))
                        {
                            $this->loadModel("CountryEnModel",array("deleted"=>2,"last_updated_by"=>$last_updated_by))->updateData("id_country",$id);
                            $this->loadModel("CountryArModel",array("deleted"=>2,"last_updated_by"=>$last_updated_by))->updateData("id_country",$id);
                            echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                            exit;
                        }else{
                            echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                            exit;
                        }
                    }
                 }
         }
        
    }

?>