<?php
    class Governate extends Controller{
		
        
        public function add()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            // get all counteries
            $dataView['counteries'] = $this->loadModel("CountryModel")->retrieveAllData("WHERE `deleted` =?",array(1));
            if(is_array($dataView['counteries']))
            {
                foreach($dataView['counteries'] as $key=>$value)
                {
                    // get ar and en Data
                    $dataView['counteriesEn'][$key] = $this->loadModel("CountryEnModel")->retriveDataById("id_country",$value['id']);
                    $dataView['counteriesAr'][$key] = $this->loadModel("CountryArModel")->retriveDataById("id_country",$value['id']);
                }
            }
            
            //start Add Anew governate
			if(isset($_POST['add']))
            {
                
                // preparing validation array
                $validationArray = array(
                                            "name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['enName'])->clear(),
                                                             "errorName"=>"Governate Name",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "ar_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['arName'])->clear(),
                                                             "errorName"=>"اسم المحافظة",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "country"=>array(
                                                             "value"=>$this->loadSecurity($_POST['country'])->clear(),
                                                             "errorName"=>"Country",
                                                             "rules"=>"required|number"
                                                          ),
                                            "longitude"=>array(
                                                             "value"=>$this->loadSecurity($_POST['long'])->clear(),
                                                             "errorName"=>"Governate Longitude",
                                                             "rules"=>"required"
                                                          ),
                                            "latitude"=>array(
                                                             "value"=>$this->loadSecurity($_POST['lat'])->clear(),
                                                             "errorName"=>"Governate Latitude",
                                                             "rules"=>"required"
                                                          ),
                                            "status"=>array(
                                                             "value"=>$this->loadSecurity($_POST['status'])->clear(),
                                                             "errorName"=>"Status",
                                                             "rules"=>"number"
                                                          ),
                                  );
                // load validation classs and pass validation data
                $dataValid = $this->loadValidation($validationArray)->formValidate();
                // check if the data is ok
                if(is_array($dataValid) && array_key_exists("success",$dataValid))
                {
                    //check if Governate En Name exists before
                    if(TRUE !== $this->loadModel("GovernateEnModel")->CheckExists("WHERE `name` =? AND `deleted`=?",array($dataValid['success']['name'],1)))
                    {
                        //check if Governate Ar Name exists before
                        if(TRUE !== $this->loadModel("GovernateArModel")->CheckExists("WHERE `name` =? AND `deleted`=?",array($dataValid['success']['ar_name'],1)))
                        {
                            // prepare data
                            $dataModel['id_country'] = $dataValid['success']['country'];
                            $dataModel['longitude'] = $dataValid['success']['longitude'];
                            $dataModel['latitude'] = $dataValid['success']['latitude'];
                            $dataModel['id_admin'] = $user_id;
                            $dataModel['status'] = $dataValid['success']['status'];
                            $dataModel['created'] = time();
                            $add = $this->loadModel("GovernateModel",$dataModel)->add();
                            if(FALSE !== $add)
                            {
                                // preparing en data
                                $dataEnModel['id_governate'] = $add;
                                $dataEnModel['name'] = $dataValid['success']['name'];
                                $dataEnModel['status'] = $dataValid['success']['status'];
                                $dataEnModel['created'] = time();
                                $addEnData = $this->loadModel("GovernateEnModel",$dataEnModel)->add();
                                // preparing ar data
                                $dataArModel['id_governate'] = $add;
                                $dataArModel['name'] = $dataValid['success']['ar_name'];
                                $dataArModel['status'] = $dataValid['success']['status'];
                                $dataArModel['created'] = time();
                                $addArData = $this->loadModel("GovernateArModel",$dataArModel)->add();
                                if(False !== $addEnData && FALSE !== $addArData)
                                {
                                   $dataView['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Added Successfully Please Wait .. </div>';
                                   header("Refresh: 2"); 
                                }else{
                                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Adding Your Data Please Try Again1</div>';
                                }
                            }else{
                                $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Adding Your Data Please Try Again2</div>';
                            }
                        }else{
                            $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Governate Arabic Name Exists Before</div>';
                        }
                    }else{
                        $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Governate English Name Exists Before</div>';
                    }
                }else{
                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                }
            }
            
			$dataView['title'] = "Add Governate";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."governate_add";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
        public function getAll()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            
            // get all governates
            $dataView['governates'] = $this->loadModel("GovernateModel")->retrieveAllData("WHERE `deleted` =?",array(1));
            if(is_array($dataView['governates']))
            {
                foreach($dataView['governates'] as $key=>$value)
                {
                    // get ar and en Data
                    $dataView['governateEn'][$key] = $this->loadModel("GovernateEnModel")->retriveDataById("id_governate",$value['id']);
                    $dataView['governateAr'][$key] = $this->loadModel("GovernateArModel")->retriveDataById("id_governate",$value['id']);
                }
            }
            
			$dataView['title'] = "Show / Edit Governates";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."governate_getall";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
        public function edit_selected()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            // get id from url
            $id = (int)$this->loadRoute()->getSegment(2);
            if($id == 0)
            {
                $this->redirect("Errors","index");
                exit();
            }
            // get data
            $dataView['governate'] = $this->loadModel("GovernateModel")->retrieveAllData("WHERE `id` =? AND `deleted` =?",array($id,1));
            if($dataView['governate'] == NULL)
            {
                $this->redirect("Errors","index");
                exit();
            }
            $dataView['governate'] = array_shift($dataView['governate']);
             // get ar and en Data
            $dataView['governateEn'] = $this->loadModel("GovernateEnModel")->retriveDataById("id_governate",$id);
            $dataView['governateAr'] = $this->loadModel("GovernateArModel")->retriveDataById("id_governate",$id);

            //start edit Governate
			if(isset($_POST['edit']))
            {
                
                // preparing validation array
                $validationArray = array(
                                            "name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['enName'])->clear(),
                                                             "errorName"=>"Governate Name",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "ar_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['arName'])->clear(),
                                                             "errorName"=>"اسم المحافظة",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "country"=>array(
                                                             "value"=>$this->loadSecurity($_POST['country'])->clear(),
                                                             "errorName"=>"Country",
                                                             "rules"=>"required|number"
                                                          ),
                                            "longitude"=>array(
                                                             "value"=>$this->loadSecurity($_POST['long'])->clear(),
                                                             "errorName"=>"Governate Longitude",
                                                             "rules"=>"required"
                                                          ),
                                            "latitude"=>array(
                                                             "value"=>$this->loadSecurity($_POST['lat'])->clear(),
                                                             "errorName"=>"Governate Latitude",
                                                             "rules"=>"required"
                                                          ),
                                            "status"=>array(
                                                             "value"=>$this->loadSecurity($_POST['status'])->clear(),
                                                             "errorName"=>"Status",
                                                             "rules"=>"number"
                                                          ),
                                  );
                // load validation classs and pass validation data
                $dataValid = $this->loadValidation($validationArray)->formValidate();
                // check if the data is ok
                if(is_array($dataValid) && array_key_exists("success",$dataValid))
                {
                    //check if Governate En Name exists before
                    if(TRUE !== $this->loadModel("GovernateEnModel")->CheckExists("WHERE `name` =? AND `id_governate` != ? AND `deleted`=?",array($dataValid['success']['name'],$id,1)))
                    {
                        //check if Governate Ar Name exists before
                        if(TRUE !== $this->loadModel("GovernateArModel")->CheckExists("WHERE `name` =? AND `id_governate` != ? AND `deleted`=?",array($dataValid['success']['ar_name'],$id,1)))
                        {
                            // prepare data
                            $dataModel['id_country'] = $dataValid['success']['country'];
                            $dataModel['longitude'] = $dataValid['success']['longitude'];
                            $dataModel['latitude'] = $dataValid['success']['latitude'];
                            $dataModel['id_admin'] = $user_id;
                            $dataModel['status'] = $dataValid['success']['status'];
                            $update = $this->loadModel("GovernateModel",$dataModel)->updateData('id',$id);
                            if(FALSE !== $update)
                            {
                                // preparing en data
                                $dataEnModel['name'] = $dataValid['success']['name'];
                                $dataEnModel['status'] = $dataValid['success']['status'];
                                $updateEnData = $this->loadModel("GovernateEnModel",$dataEnModel)->updateData("id_governate",$id);
                                // preparing ar data
                                $dataArModel['name'] = $dataValid['success']['ar_name'];
                                $dataArModel['status'] = $dataValid['success']['status'];
                                $updateArData = $this->loadModel("GovernateArModel",$dataArModel)->updateData("id_governate",$id);
                                if(False !== $updateEnData && FALSE !== $updateArData)
                                {
                                   $dataView['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Updated Successfully Please Wait .. </div>';
                                   header("Refresh: 2"); 
                                }else{
                                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Updating Your Data Please Try Again1</div>';
                                }
                            }else{
                                $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Updating Your Data Please Try Again2</div>';
                            }
                        }else{
                            $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Governate Arabic Name Exists Before</div>';
                        }
                    }else{
                        $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Governate English Name Exists Before</div>';
                    }
                }else{
                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                }
            }
            // get all counteries
            $dataView['counteries'] = $this->loadModel("CountryModel")->retrieveAllData("WHERE `deleted` =?",array(1));
            if(is_array($dataView['counteries']))
            {
                foreach($dataView['counteries'] as $key=>$value)
                {
                    // get ar and en Data
                    $dataView['counteriesEn'][$key] = $this->loadModel("CountryEnModel")->retriveDataById("id_country",$value['id']);
                    $dataView['counteriesAr'][$key] = $this->loadModel("CountryArModel")->retriveDataById("id_country",$value['id']);
                }
            }
            
            // get all interests
			$dataView['title'] = "Edit Selected Governate";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."governate_edit_selected";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
        public function updateStatus()
        {
                if(isset($_POST['action'],$_POST['id'],$_POST['status']) && $_POST['action'] == "updateStatus")
                {
                    // get User id
                    $id = (int)$_POST['id'];
                    if($id == 0)
                    {
                        $this->redirect("Errors","index");
                        exit;
                    }else{
                        // get current status
                        $currentStatus = $_POST['status'];
                        // if current status = on set it off
                        if($currentStatus == "on")
                        {
                            $setStatus = 2;
                        }else{
                            $setStatus = 1;
                        }
                        $dataModel['status'] = $setStatus;

                        if(false !== $this->loadModel("GovernateModel",$dataModel)->updateData("id", $id))
                        {
                            $this->loadModel("GovernateEnModel",$dataModel)->updateData("id_governate", $id);
                            $this->loadModel("GovernateArModel",$dataModel)->updateData("id_governate", $id);
                            echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                            exit;
                        }else{
                            echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                            exit;
                        }
                    }
                }
         }
        public function delete()
        {
                if(isset($_POST['action'],$_POST['id']) && $_POST['action'] == "deleteData")
                {
                    $id = (int)$_POST['id'];
                    if($id == 0)
                    {
                        $this->redirect("Errors","index");
                        exit;
                    }else{
                        if(FALSE !== $this->loadModel("GovernateModel",array("deleted"=>2))->updateData("id",$id))
                        {
                            $this->loadModel("GovernateEnModel",array("deleted"=>2))->updateData("id_governate",$id);
                            $this->loadModel("GovernateArModel",array("deleted"=>2))->updateData("id_governate",$id);
                            echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                            exit;
                        }else{
                            echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                            exit;
                        }
                    }
                 }
         }
        /*JSON FORMAT */
        public function retreive_all_governates_by_country_id()
        {
            if(isset($_POST['country_id'])){
                $country_id =  (int)$_POST['country_id'];
                if($country_id !== 0)
                {
                     $allGovernates = $this->loadModel("GovernateModel")->retrieveAllData("WHERE `id_country` = ? AND `deleted` =? AND `status` =?",array($country_id, 1,1));
                    if(is_array($allGovernates))
                    {
                        foreach($allGovernates as $key=>$value)
                        {
                           $allGovernatesEn[$key] = $this->loadModel("GovernateEnModel")->retriveDataById("id_governate",$value['id']);
                           $allGovernatesAr[$key] = $this->loadModel("GovernateArModel")->retriveDataById("id_governate",$value['id']);
                        }
                        $response['status'] = "success";
                        $response['governates'] = $allGovernates;
                        $response['governatesEn'] = isset($allGovernatesEn) ? $allGovernatesEn : NULL;
                        $response['governatesAr'] = isset($allGovernatesAr) ? $allGovernatesAr : NULL;;
                        echo $this->loadAjax()->DataToJson($response);
                        exit;
                    }else{
                        echo $this->loadAjax()->DataToJson(array("status"=>"null"));
                        exit;   
                    }
                }else{
                    echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                    exit;
                }
            }else{
                echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                exit;
            }
        }
        
    }

?>