<?php
    class Header_adv extends Controller{
		
        
        public function add()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            
            //start Add Anew Data
			if(isset($_POST['add']))
            {
                
                // preparing validation array
                $validationArray = array(
                                            
                                                "id_country"=>array(
                                                             "value"=>$this->loadSecurity($_POST['id_country'])->clear(),
                                                             "errorName"=>"Country",
                                                             "rules"=>"required|number"
                                                          ),
                                                "url"=>array(
                                                             "value"=>$this->loadSecurity($_POST['url'])->clear(),
                                                             "errorName"=>"Url",
                                                             "rules"=>"required|url"
                                                          ),

                                            "status"=>array(
                                                             "value"=>$this->loadSecurity($_POST['status'])->clear(),
                                                             "errorName"=>"Status",
                                                             "rules"=>"number"
                                                          ),
                                  );
                // load validation classs and pass validation data
                $dataValid = $this->loadValidation($validationArray)->formValidate();
                // check if the data is ok
                if(is_array($dataValid) && array_key_exists("success",$dataValid))
                {
                    
                    // start upload news image
                    // upload image
                    $upload = $this->loadUpload("image")->do_upload();
                    
                    //if there is no errors
                    if (!array_key_exists('uploadError', $upload)) 
                    {
                        // prepare data model
                        $dataModel['image'] = $upload['uploaded'][0];
                        $dataModel['id_country'] = $dataValid['success']['id_country'];
                        $dataModel['link'] = $dataValid['success']['url'];
                        $dataModel['created'] = time();
                        $dataModel['status'] = $dataValid['success']['status'];
                        // add news
                        $add = $this->loadModel("HeaderAdvModel",$dataModel)->add();
                        if(FALSE !== $add)
                        {
                            $dataView['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Added Successfully Please Wait .. </div>'; 
                            header("Refresh: 2");
                        }else{
                            $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Adding Your Data</div>';
                        }
                    }else{
                        $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Slider Image Is Required (Max Image Size 2MB)</div>';
                    }
                }else{
                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                }
            }
            $dataView['countries'] = $this->loadModel("CountryModel")->retrieveAllData("WHERE `status` =? AND `deleted` = ?",array(1,1));
            if(is_array($dataView['countries']))
            {
                foreach($dataView['countries'] as $key=>$value)
                {
                    // get ar and en Data
                    $dataView['countriesLang'][$key] = $this->loadModel("CountryEnModel")->retriveDataById("id_country",$value['id']);
                }
            }
			$dataView['title'] = "Add a New Header Adv";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."header_adv_add";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
        public function getAll()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            
            // get all Data
            $dataView['advsData'] = $this->loadModel("HeaderAdvModel")->retrieveAllData("WHERE `deleted` =?",array(1));
			if(is_array($dataView['advsData']))
            {
                foreach($dataView['advsData'] as $key=>$value)
                {
                    $dataView['countriesEn'][$key] = $this->loadModel("CountryEnModel")->retriveDataById("id_country",$value['id_country']);
                    $dataView['countriesAr'][$key] = $this->loadModel("CountryArModel")->retriveDataById("id_country",$value['id_country']);
                }
            }
            
            $dataView['title'] = "Show / Edit Header Adv";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."header_adv_getall";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
        public function edit_selected()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            // get id from url
            $id = (int)$this->loadRoute()->getSegment(2);
            if($id == 0)
            {
                $this->redirect("Errors","index");
                exit();
            }
            // get data
            $dataView['adv'] = $this->loadModel("HeaderAdvModel")->retrieveAllData("WHERE `id` =? AND `deleted` =?",array($id,1));
            if($dataView['adv'] == NULL)
            {
                $this->redirect("Errors","index");
                exit();
            }
            $dataView['adv'] = array_shift($dataView['adv']);

            //start edit Data
			if(isset($_POST['edit']))
            {
                
                // preparing validation array
                $validationArray = array(
                                            "id_country"=>array(
                                                             "value"=>$this->loadSecurity($_POST['id_country'])->clear(),
                                                             "errorName"=>"Country",
                                                             "rules"=>"required|number"
                                                          ),
                                                "url"=>array(
                                                             "value"=>$this->loadSecurity($_POST['url'])->clear(),
                                                             "errorName"=>"Url",
                                                             "rules"=>"required|url"
                                                          ),
                                            
                                               
                                            "status"=>array(
                                                             "value"=>$this->loadSecurity($_POST['status'])->clear(),
                                                             "errorName"=>"Status",
                                                             "rules"=>"number"
                                                          ),
                                  );
                // load validation classs and pass validation data
                $dataValid = $this->loadValidation($validationArray)->formValidate();
                // check if the data is ok
                if(is_array($dataValid) && array_key_exists("success",$dataValid))
                {
                    // prepare data model
                    $dataModel['id_country'] = $dataValid['success']['id_country'];
                    $dataModel['link'] = $dataValid['success']['url'];
                    $dataModel['created'] = time();
                    $dataModel['status'] = $dataValid['success']['status'];
                    // update data
                    $update = $this->loadModel("HeaderAdvModel",$dataModel)->updateData("id",$id);
                    if(FALSE !== $update)
                    {
                        
                        $dataView['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Updated Successfully Please Wait .. </div>'; 
                        header("Refresh: 2");
                    }else{
                        $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Updating Your Data</div>';
                    }
                    
                }else{
                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                }
            }
            
            $dataView['countries'] = $this->loadModel("CountryModel")->retrieveAllData("WHERE `status` =? AND `deleted` = ?",array(1,1));
            if(is_array($dataView['countries']))
            {
                foreach($dataView['countries'] as $key=>$value)
                {
                    // get ar and en Data
                    $dataView['countriesLang'][$key] = $this->loadModel("CountryEnModel")->retriveDataById("id_country",$value['id']);
                }
            }
            // set page title
			$dataView['title'] = "Edit Selected Adv";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."header_adv_edit_selected";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }

        public function updateStatus()
        {
                if(isset($_POST['action'],$_POST['id'],$_POST['status']) && $_POST['action'] == "updateStatus")
                {
                    // get User id
                    $id = (int)$_POST['id'];
                    if($id == 0)
                    {
                        $this->redirect("Errors","index");
                        exit;
                    }else{
                        // get current status
                        $currentStatus = $_POST['status'];
                        // if current status = on set it off
                        if($currentStatus == "on")
                        {
                            $setStatus = 2;
                        }else{
                            $setStatus = 1;
                        }
                        $dataModel['status'] = $setStatus;

                        if(false !== $this->loadModel("HeaderAdvModel",$dataModel)->updateData("id", $id))
                        {
                         echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                         exit;
                        }else{
                            echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                            exit;
                        }
                    }
                }
         }
        public function update_image()
        {
                //get id
                $id = (int)$_POST['field_id'];
                 if($id == 0)
                {
                    $this->redirect("Errors","index");
                    exit;
                }else{
                        $upload = $this->loadUpload("image_name")->do_upload();
                       // check if there is error on image
                       if(array_key_exists("uploadError",$upload))
                       {
                           echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                            exit;

                       }else{
                           $dataModel['image'] = $upload['uploaded'][0];
                           if(false !== $this->loadModel("HeaderAdvModel",$dataModel)->updateData("id", $id))
                           {
                               echo $this->loadAjax()->DataToJson(array("status"=>"success","newImage"=>$dataModel['image']));
                                exit; 
                           }else{
                              echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                            exit;
                           }
                       }
                    }  
        }
        public function delete()
        {
                if(isset($_POST['action'],$_POST['id']) && $_POST['action'] == "deleteData")
                {
                    $id = (int)$_POST['id'];
                    if($id == 0)
                    {
                        $this->redirect("Errors","index");
                        exit;
                    }else{
                        if(FALSE !== $this->loadModel("HeaderAdvModel",array("deleted"=>2))->updateData("id",$id))
                        {
                            echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                            exit;
                        }else{
                            echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                            exit;
                        }
                    }
                 }
         }
        
    }

?>