<?php
    class Job extends Controller{
		
        
        
        public function add()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("error","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            
            
            //start Add Anew Data
			if(isset($_POST['add']))
            {
                
                // preparing validation array
                $validationArray = array(
                                            "title"=>array(
                                                             "value"=>$this->loadSecurity($_POST['enTitle'])->clear(),
                                                             "errorName"=>"Job Title",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "ar_title"=>array(
                                                             "value"=>$this->loadSecurity($_POST['arTitle'])->clear(),
                                                             "errorName"=>"اسم الوظيفه",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "description"=>array(
                                                             "value"=>$_POST['enDescription'],
                                                             "errorName"=>"Job Description",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "ar_description"=>array(
                                                             "value"=>$_POST['arDescription'],
                                                             "errorName"=>"وصف الوظيفه",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "id_country"=>array(
                                                             "value"=>$this->loadSecurity($_POST['country'])->clear(),
                                                             "errorName"=>"Country",
                                                             "rules"=>"number"
                                                          ),
                                            "status"=>array(
                                                             "value"=>$this->loadSecurity($_POST['status'])->clear(),
                                                             "errorName"=>"Status",
                                                             "rules"=>"number"
                                                          ),
                                  );
                // load validation classs and pass validation data
                $dataValid = $this->loadValidation($validationArray)->formValidate();
                // check if the data is ok
                if(is_array($dataValid) && array_key_exists("success",$dataValid))
                {
                    
                    // prepare data
                    $dataModel['id_admin'] = $user_id;
                    $dataModel['id_country'] = $dataValid['success']['id_country'];
                    $dataModel['status'] = $dataValid['success']['status'];
                    $dataModel['created'] = time();
                    
                    $add = $this->loadModel("JobModel",$dataModel)->add();
                    if(FALSE !== $add)
                    {
                        // preparing en data
                        $dataEnModel['id_job'] = $add;
                        $dataEnModel['title'] = $dataValid['success']['title'];
                        $dataEnModel['description'] = $dataValid['success']['description'];
                        $addEnData = $this->loadModel("JobEnModel",$dataEnModel)->add();
                        // preparing ar data
                        $dataArModel['id_job'] = $add;
                        $dataArModel['title'] = $dataValid['success']['ar_title'];
                        $dataArModel['description'] = $dataValid['success']['ar_description'];
                        $addArData = $this->loadModel("JobArModel",$dataArModel)->add();
                        if(False !== $addEnData && FALSE !== $addArData)
                        {
                            $dataView['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Added Successfully Please Wait .. </div>';
                            header("Refresh: 2"); 
                        }else{
                            $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Adding Your Data Please Try Again</div>';
                        }
                    }else{
                        $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Adding Your Data Please Try Again</div>';
                    } 
                    
                    
                }else{
                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                }
            }
            
            // get all counteries
            $dataView['counteries'] = $this->loadModel("CountryModel")->retrieveAllData("WHERE `deleted` =?",array(1));
            if(is_array($dataView['counteries']))
            {
                foreach($dataView['counteries'] as $key=>$value)
                {
                    // get ar and en Data
                    $dataView['counteriesEn'][$key] = $this->loadModel("CountryEnModel")->retriveDataById("id_country",$value['id']);
                    $dataView['counteriesAr'][$key] = $this->loadModel("CountryArModel")->retriveDataById("id_country",$value['id']);
                }
            }
            
			$dataView['title'] = "Add Job";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."job_add";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
        public function getAll()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("error","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            
            // get all Jobs
            
            $dataView['jobs'] = $this->loadModel("JobModel")->retrieveAllData("WHERE `deleted` =?",array(1));
            if(is_array($dataView['jobs']))
            {
                foreach($dataView['jobs'] as $key=>$value)
                {
                    // get ar and en Data
                    $dataView['jobsEn'][$key] = $this->loadModel("JobEnModel")->retriveDataById("id_job",$value['id']);
                    $dataView['jobsAr'][$key] = $this->loadModel("JobArModel")->retriveDataById("id_job",$value['id']);
                    // get job country
                    $dataView['countryEn'][$key] = $this->loadModel("CountryEnModel")->retriveDataById("id_country",$value['id_country']);
                    $dataView['countryAr'][$key] = $this->loadModel("CountryArModel")->retriveDataById("id_country",$value['id_country']);
                }
            }
            
			$dataView['title'] = "Show / Edit Job";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."job_getall";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
        public function edit_selected()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("error","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            // get id from url
            $id = (int)$this->loadRoute()->getSegment(2);
            if($id == 0)
            {
                $this->redirect("error","index");
                exit();
            }
            // get data
            $dataView['job'] = $this->loadModel("JobModel")->retrieveAllData("WHERE `id` =? AND `deleted` =?",array($id,1));
            if($dataView['job'] == NULL)
            {
                $this->redirect("error","index");
                exit();
            }
            $dataView['job'] = array_shift($dataView['job']);
             // get ar and en Data
            $dataView['jobEn'] = $this->loadModel("JobEnModel")->retriveDataById("id_job",$id);
            $dataView['jobAr'] = $this->loadModel("JobArModel")->retriveDataById("id_job",$id);

            //start Edit Job
			if(isset($_POST['edit']))
            {
                
                // preparing validation array
                $validationArray = array(
                                            "title"=>array(
                                                             "value"=>$this->loadSecurity($_POST['enTitle'])->clear(),
                                                             "errorName"=>"Job Title",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "ar_title"=>array(
                                                             "value"=>$this->loadSecurity($_POST['arTitle'])->clear(),
                                                             "errorName"=>"اسم الوظيفه",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "description"=>array(
                                                             "value"=>$this->loadSecurity($_POST['enDescription'])->clear(),
                                                             "errorName"=>"Job Description",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "ar_description"=>array(
                                                             "value"=>$this->loadSecurity($_POST['arDescription'])->clear(),
                                                             "errorName"=>"وصف الوظيفه",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "id_country"=>array(
                                                             "value"=>$this->loadSecurity($_POST['country'])->clear(),
                                                             "errorName"=>"Country",
                                                             "rules"=>"number"
                                                          ),
                                            "status"=>array(
                                                             "value"=>$this->loadSecurity($_POST['status'])->clear(),
                                                             "errorName"=>"Status",
                                                             "rules"=>"number"
                                                          ),
                                  );
                // load validation classs and pass validation data
                $dataValid = $this->loadValidation($validationArray)->formValidate();
                // check if the data is ok
                if(is_array($dataValid) && array_key_exists("success",$dataValid))
                {
                    // prepare data
                    $dataModel['id_country'] = $dataValid['success']['id_country'];
                    $dataModel['status'] = $dataValid['success']['status'];
                    
                    $updateData = $this->loadModel("JobModel",$dataModel)->UpdateData("id",$id);
                    if(FALSE !== $updateData)
                    {
                        // preparing en data
                        $dataEnModel['title'] = $dataValid['success']['title'];
                        $dataEnModel['description'] = $dataValid['success']['description'];
                        $updateEnData = $this->loadModel("JobEnModel",$dataEnModel)->UpdateData("id_job",$id);
                        // preparing ar data
                        $dataArModel['title'] = $dataValid['success']['ar_title'];
                        $dataArModel['description'] = $dataValid['success']['ar_description'];
                        $updateArData = $this->loadModel("JobArModel",$dataArModel)->UpdateData("id_job",$id);
                        if(False !== $updateEnData && FALSE !== $updateArData)
                        {
                           $dataView['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Updated Successfully Please Wait .. </div>';
                           header("Refresh: 2"); 
                        }else{
                            $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Updating Your Data Please Try Again</div>';
                        }
                    }else{
                        $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Updating Your Data Please Try Again</div>';
                    } 
                    
                }else{
                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                }
            }
            
            // get all counteries
            $dataView['counteries'] = $this->loadModel("CountryModel")->retrieveAllData("WHERE `deleted` =?",array(1));
            if(is_array($dataView['counteries']))
            {
                foreach($dataView['counteries'] as $key=>$value)
                {
                    // get ar and en Data
                    $dataView['counteriesEn'][$key] = $this->loadModel("CountryEnModel")->retriveDataById("id_country",$value['id']);
                    $dataView['counteriesAr'][$key] = $this->loadModel("CountryArModel")->retriveDataById("id_country",$value['id']);
                }
            }
			$dataView['title'] = "Edit Selected Job";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."job_edit_selected";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        public function show_applied_users()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("error","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            // get id from url
            $id = (int)$this->loadRoute()->getSegment(2);
            if($id == 0)
            {
                $this->redirect("error","index");
                exit();
            }
            // get data
            $dataView['job'] = $this->loadModel("JobModel")->retrieveAllData("WHERE `id` =? AND `deleted` =?",array($id,1));
            if($dataView['job'] == NULL)
            {
                $this->redirect("error","index");
                exit();
            }
            $dataView['job'] = array_shift($dataView['job']);
             // get ar and en Data
            $dataView['jobEn'] = $this->loadModel("JobEnModel")->retriveDataById("id_job",$id);
            $dataView['jobAr'] = $this->loadModel("JobArModel")->retriveDataById("id_job",$id);

            // get all Jobs
            
            $dataView['jobs_applied'] = $this->loadModel("JobAppliedModel")->retrieveAllData("WHERE `id_job` = ? AND `deleted` =?",array($id,1));
            
			$dataView['title'] = "Show Job Applied";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."job_applied_getall";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        public function show_selected_applied_user()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("error","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            // get id from url
            $id = (int)$this->loadRoute()->getSegment(2);
            if($id == 0)
            {
                $this->redirect("error","index");
                exit();
            }
            // get data
            $dataView['job_applied'] = $this->loadModel("JobAppliedModel")->retrieveAllData("WHERE `id` =? AND `deleted` =?",array($id,1));
            if($dataView['job_applied'] == NULL)
            {
                $this->redirect("error","index");
                exit();
            }
            $dataView['job_applied'] = array_shift($dataView['job_applied']);
             // get ar and en Data
            $dataView['job'] = $this->loadModel("JobModel")->retriveDataById("id",$dataView['job_applied']['id_job']);
            $dataView['jobEn'] = $this->loadModel("JobEnModel")->retriveDataById("id_job",$dataView['job_applied']['id_job']);
            $dataView['jobAr'] = $this->loadModel("JobArModel")->retriveDataById("id_job",$dataView['job_applied']['id_job']);
            $dataView['countryEn'] = $this->loadModel("CountryEnModel")->retriveDataById("id_country",$dataView['job']['id_country']);
            $dataView['countryAr'] = $this->loadModel("CountryArModel")->retriveDataById("id_country",$dataView['job']['id_country']);

            
            
			$dataView['title'] = "Show Selected Job Apply";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."job_selected_applied";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        public function update_image()
        {
                //get id
                $id = (int)$_POST['field_id'];
                 if($id == 0)
                {
                    echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                    exit;
                }else{
                        $upload = $this->loadUpload("image_name")->do_upload();
                       // check if there is error on image
                       if(array_key_exists("uploadError",$upload))
                       {
                           echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                            exit;

                       }else{
                           $dataModel['image'] = $upload['uploaded'][0];
                           if(false !== $this->loadModel("JobModel",$dataModel)->updateData("id", $id))
                           {
                               echo $this->loadAjax()->DataToJson(array("status"=>"success","newImage"=>$dataModel['image']));
                                exit; 
                           }else{
                              echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                            exit;
                           }
                       }
                    }  
        }
        public function updateStatus()
        {
                if(isset($_POST['action'],$_POST['id'],$_POST['status']) && $_POST['action'] == "updateStatus")
                {
                    // get User id
                    $id = (int)$_POST['id'];
                    if($id == 0)
                    {
                        $this->redirect("error","index");
                        exit;
                    }else{
                        // get current status
                        $currentStatus = $_POST['status'];
                        // if current status = on set it off
                        if($currentStatus == "on")
                        {
                            $setStatus = 2;
                        }else{
                            $setStatus = 1;
                        }
                        $dataModel['status'] = $setStatus;

                        if(false !== $this->loadModel("JobModel",$dataModel)->updateData("id", $id))
                        {
                         echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                         exit;
                        }else{
                            echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                            exit;
                        }
                    }
                }
         }
        
        public function delete()
        {
                if(isset($_POST['action'],$_POST['id']) && $_POST['action'] == "deleteData")
                {
                    $id = (int)$_POST['id'];
                    if($id == 0)
                    {
                        $this->redirect("error","index");
                        exit;
                    }else{
                        if(FALSE !== $this->loadModel("JobModel",array("deleted"=>2))->updateData("id",$id))
                        {
                            echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                            exit;
                        }else{
                            echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                            exit;
                        }
                    }
                 }
         }
        public function delete_user_applied()
        {
                if(isset($_POST['action'],$_POST['id']) && $_POST['action'] == "deleteData")
                {
                    $id = (int)$_POST['id'];
                    if($id == 0)
                    {
                        $this->redirect("error","index");
                        exit;
                    }else{
                        if(FALSE !== $this->loadModel("JobAppliedModel",array("deleted"=>2))->updateData("id",$id))
                        {
                            echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                            exit;
                        }else{
                            echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                            exit;
                        }
                    }
                 }
         }
        
        
    }

?>