<?php
    class Offer extends Controller{


        public function add()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            
            
            //start Add Anew data
            if(isset($_POST['add']))
            {
                                            
                    // preparing validation array
                    $validationArray = array(
                                            
                                                "id_category"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['id_category'])->clear(),
                                                                 "errorName"=>"Main Category",
                                                                 "rules"=>"required|number"
                                                              ),
                                                "id_sub_category"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['id_sub_category'])->clear(),
                                                                 "errorName"=>"Sub Category",
                                                              ),
                                                "title"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['title'])->clear(),
                                                                 "errorName"=>"Product Title",
                                                                 "rules"=>"required|min-length[3]"
                                                              ),
                                                    "slug"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['slug'])->clear(),
                                                                 "errorName"=>"Product Slug",
                                                                 "rules"=>"required|min-length[3]"
                                                              ),
                                                "description"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['description'])->clear(),
                                                                 "errorName"=>"Description",
                                                                 "rules"=>"min-length[5]"
                                                              ),
                                                "keywords"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['keywords'])->clear(),
                                                                 "errorName"=>"keywords",
                                                              ),
                                                "id_brand"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['id_brand'])->clear(),
                                                                 "errorName"=>"Brand",
                                                                 "rules"=>"number"
                                                              ),
                                                "code"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['code'])->clear(),
                                                                 "errorName"=>"code",
                                                              ),
                                                "price"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['price'])->clear(),
                                                                 "errorName"=>"Price",
                                                                 "rules"=>"required"
                                                              ),
                                                "title_ar"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['title_ar'])->clear(),
                                                                 "errorName"=>"عنوان المنتج",
                                                                 "rules"=>"required|min-length[3]"
                                                              ),
                                                    "slug_ar"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['slug_ar'])->clear(),
                                                                 "errorName"=>"مختصر المنتج",
                                                                 "rules"=>"required|min-length[3]"
                                                              ),
                                                "description_ar"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['description_ar'])->clear(),
                                                                 "errorName"=>"الوصف",
                                                                 "rules"=>"min-length[5]"
                                                              ),
                                                "keywords_ar"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['keywords_ar'])->clear(),
                                                                 "errorName"=>"الكلمات الدليلية",
                                                              ),
                                                "status"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['status'])->clear(),
                                                                 "errorName"=>"Status",
                                                                 "rules"=>"required|number"
                                                              ),
												"special"=>array(
													"value"=>$this->loadSecurity($_POST['special'])->clear(),
													"errorName"=>"special Product",
													"rules"=>"number"
												),
												"discount_prec"=>array(
													"value"=>$this->loadSecurity($_POST['discount_prec'])->clear(),
													"errorName"=>"Discount Precentage",
												),

                                      );
                    // load validation classs and pass validation data
                    $dataValid = $this->loadValidation($validationArray)->formValidate();
                    // check if the data is ok
                    if(is_array($dataValid) && array_key_exists("success",$dataValid))
                    {
                        // upload main image
                        $upload = $this->loadUpload("image")->do_upload();
                        //if there is no errors
                        if (!array_key_exists('uploadError', $upload)) 
                        {
                            $productDataModel['id_category'] = $dataValid['success']['id_category'];
                            $productDataModel['id_sub_category'] = $dataValid['success']['id_sub_category'];
                            $productDataModel['id_brand'] = $dataValid['success']['id_brand'];
                            $productDataModel['code'] = $dataValid['success']['code'];
							$productDataModel['special']=$dataValid['success']['special'];
							$productDataModel['image'] = $upload['uploaded'][0];
                            $productDataModel['status'] = $dataValid['success']['status'];
                            $productDataModel['created'] = time();
                            $productDataModel['created_by'] = $user_id;
                            $productDataModel['last_updated_by'] = $user_id;
                           
                            // add data
                            $add = $this->loadModel("OfferModel",$productDataModel)->add();
                            if(FALSE !== $add)
                            {
                                // add data en
                                $offerEnDataModel['id_offer'] = $add;
                                $offerEnDataModel['title'] = $dataValid['success']['title'];
                                $offerEnDataModel['slug'] = $dataValid['success']['slug'];
                                $offerEnDataModel['description'] = $dataValid['success']['description'];
                                $offerEnDataModel['keywords'] = $dataValid['success']['keywords'];
                                $offerEnDataModel['status'] = $dataValid['success']['status'];
                                $offerEnDataModel['created'] = time();
                                $this->loadModel("OfferEnModel",$offerEnDataModel)->add();
                                // add data ar
                                $offerArDataModel['id_offer'] = $add;
                                $offerArDataModel['title'] = $dataValid['success']['title_ar'];
                                $offerArDataModel['slug'] = $dataValid['success']['slug_ar'];
                                $offerArDataModel['description'] = $dataValid['success']['description_ar'];
                                $offerArDataModel['keywords'] = $dataValid['success']['keywords_ar'];
                                $offerArDataModel['status'] = $dataValid['success']['status'];
                                $offerArDataModel['created'] = time();
                                $this->loadModel("OfferArModel",$offerArDataModel)->add();
                                // add data to offer price
                                $offerPriceDataModel['id_offer'] = $add;
                                $offerPriceDataModel['id_user'] = $user_id;
                                $offerPriceDataModel['price_per_item'] = $dataValid['success']['price'];
                                $offerPriceDataModel['created'] = time();
								$descount = ((float)$dataValid['success']['price'] * (float)$dataValid['success']['discount_prec']) / 100 ;
								//start collect all data
								$offerPriceDataModel['price_after_discount'] = $dataValid['success']['price'] - $descount;
								$offerPriceDataModel['discount']=$dataValid['success']['discount_prec'];

								$this->loadModel("OfferDefaultPriceModel",$offerPriceDataModel)->add();
                                // add data to offer report
                                $offerReportModel['id_offer'] = $add;
                                $offerReportModel['id_category']=$dataValid['success']['id_category'];
                                $offerReportModel['id_sub_category']=$dataValid['success']['id_sub_category'];
                                $offerReportModel['created'] = time();
                                $addReport = $this->loadModel("OfferReportModel",$offerReportModel)->add();
                                
                                // start add offer images if found
                                $albumImagesData = $this->loadUpload("album",FALSE)->do_upload();
                                // check if there is error on image
                                if(!array_key_exists("uploadError",$albumImagesData))
                                {
                                    if($albumImagesData['uploaded'][0] != NULL)
                                    {
                                        foreach($albumImagesData['uploaded'] as $value)
                                         {
                                            $albumImages['id_offer'] = $add;
                                            $albumImages['image'] = $value;
                                            $albumImages['created'] = time();
                                            // load Model To Add Gallery Name
                                            $addImages = $this->loadModel("OfferImagesModel",$albumImages)->add();
                                        }
                                        
                                    }
                                }
                                // start add offrer attributes if found
                                $offerAttributes = $_POST['attr'];
                                $offerAttributesVlues = $_POST['attr_values_en'];
                                $offerAttributesVluesAr = $_POST['attr_values_ar'];
                                if(is_array($offerAttributes))
                                {
                                      foreach($offerAttributes as $key=>$data)
                                     {
                                        if($data != 0 || $offerAttributesVlues[$key] != NULL || $offerAttributesVluesAr[$key] != NULL)
                                        {
                                            $offerAttrsDataModel['id_offer'] = $add;
                                            $offerAttrsDataModel['id_attribute'] = $data;
                                            $offerAttrsDataModel['value'] = $offerAttributesVlues[$key];
                                            $offerAttrsDataModel['value_ar'] = $offerAttributesVluesAr[$key];
                                            $offerAttrsDataModel['created'] = time();
                                            // load Model To Add attrs data
                                            $addOfferAttributes = $this->loadModel("OfferAttributesModel",$offerAttrsDataModel)->add();
                                        }
                                    }  
                                }

                                
                                // update category report for total offers
                                $updateCategoryReport = $this->loadModel("CategoryReportModel")->retrieveDataByQuery("UPDATE `category_report` SET `total_offers` = `total_offers` + ? WHERE `id_category` = ?",array(1,$dataValid['success']['id_category']));
                                // update brand report for total offers
                                $updateBrandReport = $this->loadModel("BrandReportModel")->retrieveDataByQuery("UPDATE `brand_report` SET `total_offers` = `total_offers` + ? WHERE `id_brand` = ?",array(1,$dataValid['success']['id_brand']));
                                // update Sub category report for total offers                          
                                $updateSubCategoryReport = $this->loadModel("CategoryReportModel")->retrieveDataByQuery("UPDATE `category_report` SET `total_offers` = `total_offers` + ? WHERE `id_category` = ?",array(1,$dataValid['success']['id_sub_category']));
                                $dataView['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Added Successfully Please Wait .. </div>';
                             header("Refresh: 2");

                            }else{
                                $dataView['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Adding Your Data Please Try Again2</div>';
                            }
                        }else{
                            $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Can Not Upload Main Image (Max Size : 5MB & Allowed Extensions : png - jpg - jpeg)</div>';
                        }
                    }else{
                        $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                    }
            }
            

            // get categories
            $dataView['allCategories'] = $this->loadModel("CategoryModel")->retrieveAllData("WHERE `id_category` IS NULL AND `status` =? AND `deleted` =?",array(1,1));

            if(is_array($dataView['allCategories']))
            {
                foreach($dataView['allCategories'] as $key=>$data)
                {
                    $dataView['allCategoriesEn'][$key] =  $this->loadModel("CategoryEnModel")->retriveDataById("id_category",$data['id']);
                    $dataView['allCategoriesAr'][$key] =  $this->loadModel("CategoryArModel")->retriveDataById("id_category",$data['id']);
                }
            }
            // get brands
            $dataView['allBrands'] = $this->loadModel("BrandModel")->retrieveAllData("WHERE `status` =? AND `deleted` = ?",array(1,1));

            if(is_array($dataView['allBrands']))
            {
                foreach($dataView['allBrands'] as $key=>$data)
                {
                    $dataView['allBrandsEn'][$key] =  $this->loadModel("BrandEnModel")->retriveDataById("id_brand",$data['id']);
                    $dataView['allBrandsAr'][$key] =  $this->loadModel("BrandArModel")->retriveDataById("id_brand",$data['id']);
                }
            }
            
            $dataView['title'] = "Add Product";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            //$TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."offer_add";
			$TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "offer" . DIRECTORY_SEPARATOR . "offer_add";

			// load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        public function today_offers()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            $todayDate = date('Y/m/d');
            $dataView['offers'] = $this->loadModel("OfferModel")->retrieveAllData("WHERE `created` >= ? AND `deleted` =?",array(strtotime($todayDate),1));
            if(is_array($dataView['offers']))
            {
                foreach($dataView['offers'] as $key=>$value)
                {
                    $dataView['offersCategoriesEn'][$key] = $this->loadModel("CategoryEnModel")->retriveDataById("id_category",$value['id_category']);
                    $dataView['offersCategoriesAr'][$key] = $this->loadModel("CategoryArModel")->retriveDataById("id_category",$value['id_category']);
                    $dataView['offersDataEn'][$key] = $this->loadModel("OfferEnModel")->retriveDataById("id_offer",$value['id']);
                    $dataView['offersDataAr'][$key] = $this->loadModel("OfferArModel")->retriveDataById("id_offer",$value['id']);
					$dataView['latestPrice'][$key]	= $this->loadModel("OfferDefaultPriceModel")->retrieveAllData("WHERE `id_offer` =? AND `deleted`=? ORDER BY id Desc LIMIT 1",array($value['id'],1));
					if(is_array($dataView['latestPrice'][$key]))
					{
						$dataView['latestPrice'][$key]['price'] = $dataView['latestPrice'][$key][0]['price_per_item'];
					}else{
						$dataView['latestPrice'][$key]['price'] = 0;
					}
				}
            }
            //var_dump($dataView['latestPrice']);
            //get product latest price
            $dataView['title'] = "Show Today product";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."offers_today_getall";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        public function month_offers()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            $monthDate = date('Y/m/01');
            $dataView['offers'] = $this->loadModel("OfferModel")->retrieveAllData("WHERE `created` >= ? AND `deleted` =?",array(strtotime($monthDate),1));
            if(is_array($dataView['offers']))
            {
                foreach($dataView['offers'] as $key=>$value)
                {
                    $dataView['offersCategoriesEn'][$key] = $this->loadModel("CategoryEnModel")->retriveDataById("id_category",$value['id_category']);
                    $dataView['offersCategoriesAr'][$key] = $this->loadModel("CategoryArModel")->retriveDataById("id_category",$value['id_category']);
                    $dataView['offersDataEn'][$key] = $this->loadModel("OfferEnModel")->retriveDataById("id_offer",$value['id']);
                    $dataView['offersDataAr'][$key] = $this->loadModel("OfferArModel")->retriveDataById("id_offer",$value['id']);
					$dataView['latestPrice'][$key]	= $this->loadModel("OfferDefaultPriceModel")->retrieveAllData("WHERE `id_offer` =? AND `deleted`=? ORDER BY id Desc LIMIT 1",array($value['id'],1));
					if(is_array($dataView['latestPrice'][$key]))
					{
						$dataView['latestPrice'][$key]['price'] = $dataView['latestPrice'][$key][0]['price_per_item'];
					}else{
						$dataView['latestPrice'][$key]['price'] = 0;
					}

				}
            }				
            $dataView['title'] = "Show Month product";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."offers_month_getall";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        public function unapproved_offers()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            $dataView['offers'] = $this->loadModel("OfferModel")->retrieveAllData("WHERE `approved` = ? AND `deleted` =?",array(2,1));
            if(is_array($dataView['offers']))
            {
                foreach($dataView['offers'] as $key=>$value)
                {
                    $dataView['offersCategoriesEn'][$key] = $this->loadModel("CategoryEnModel")->retriveDataById("id_category",$value['id_category']);
                    $dataView['offersCategoriesAr'][$key] = $this->loadModel("CategoryArModel")->retriveDataById("id_category",$value['id_category']);
                    $dataView['offersDataEn'][$key] = $this->loadModel("OfferEnModel")->retriveDataById("id_offer",$value['id']);
                    $dataView['offersDataAr'][$key] = $this->loadModel("OfferArModel")->retriveDataById("id_offer",$value['id']);
					$dataView['latestPrice'][$key]	= $this->loadModel("OfferDefaultPriceModel")->retrieveAllData("WHERE `id_offer` =? AND `deleted`=? ORDER BY id Desc LIMIT 1",array($value['id'],1));
					if(is_array($dataView['latestPrice'][$key]))
					{
						$dataView['latestPrice'][$key]['price'] = $dataView['latestPrice'][$key][0]['price_per_item'];
					}else{
						$dataView['latestPrice'][$key]['price'] = 0;
					}

				}

			}

            
            $dataView['title'] = "Show UnApproved Products";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."offers_unapproved_getall";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        public function offers_report()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            
            if(isset($_POST['search']))
            {
                
                // preparing validation array
                $validationArray = array(
                                            "date_from"=>array(
                                                             "value"=>$this->loadSecurity($_POST['dateFrom'])->clear(),
                                                             "errorName"=>"Date From",
                                                             "rules"=>"required"
                                                          ),
                                            "date_to"=>array(
                                                             "value"=>$this->loadSecurity($_POST['dateTo'])->clear(),
                                                             "errorName"=>"Date To",
                                                             "rules"=>"required"
                                                          ),
                                  );
                // load validation classs and pass validation data
                $dataValid = $this->loadValidation($validationArray)->formValidate();
                // check if the data is ok
                if(is_array($dataValid) && array_key_exists("success",$dataValid))
                { 
                    $dataView['offers'] = $this->loadModel("OfferModel")->retrieveAllData("WHERE `created` BETWEEN ? AND ? AND `deleted` =?",array(strtotime($dataValid['success']['date_from']),strtotime($dataValid['success']['date_to']),1));
                    if(is_array($dataView['offers']))
                    {
                        foreach($dataView['offers'] as $key=>$value)
                        {
                            $dataView['offersCategoriesEn'][$key] = $this->loadModel("CategoryEnModel")->retriveDataById("id_category",$value['id_category']);
                            $dataView['offersCategoriesAr'][$key] = $this->loadModel("CategoryArModel")->retriveDataById("id_category",$value['id_category']);
                            $dataView['offersDataEn'][$key] = $this->loadModel("OfferEnModel")->retriveDataById("id_offer",$value['id']);
                            $dataView['offersDataAr'][$key] = $this->loadModel("OfferArModel")->retriveDataById("id_offer",$value['id']);
							$dataView['latestPrice'][$key]	= $this->loadModel("OfferDefaultPriceModel")->retrieveAllData("WHERE `id_offer` =? AND `deleted`=? ORDER BY id Desc LIMIT 1",array($value['id'],1));
							if(is_array($dataView['latestPrice'][$key]))
							{
								$dataView['latestPrice'][$key]['price'] = $dataView['latestPrice'][$key][0]['price_per_item'];
							}else{
								$dataView['latestPrice'][$key]['price'] = 0;
							}

						}
                    }		 
                }else{
                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                }
            }
            
            $dataView['title'] = "Make Products Report";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."offers_report_make";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        public function edit_selected()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            // get id from url
            $id = (int)$this->loadRoute()->getSegment(2);
            if($id == 0)
            {
                $this->redirect("Errors","index");
                exit();
            }
            // get offer data
            $dataView['offer'] = $this->loadModel("OfferModel")->retrieveAllData("WHERE `id` =? AND `deleted` =?",array($id,1));
            if(!is_array($dataView['offer']))
            {
                $this->redirect("Errors","index");
                exit();
            }
            $dataView['offer'] = array_shift($dataView['offer']);
            // offer lang data
            $dataView['offerEnData'] = $this->loadModel("OfferEnModel")->retriveDataById("id_offer",$id);
            $dataView['offerArData'] = $this->loadModel("OfferArModel")->retriveDataById("id_offer",$id);
            // get offer summery
            $dataView['offerSummery'] = $this->loadModel("OfferReportModel")->retriveDataById("id_offer",$id);
            // get offer images	
            $dataView['offerImages'] = $this->loadModel("OfferImagesModel")->retrieveAllData("WHERE `id_offer` =? AND `status` =? AND `deleted` = ?",array($id,1,1));
            // get main category sub categories
            $dataView['subCategories'] = $this->loadModel("CategoryModel")->retrieveAllData("WHERE `id_category` =? AND `status` =? AND `deleted` = ?",array($dataView['offer']['id_category'],1,1));
            if(is_array($dataView['subCategories']))
            {
                foreach($dataView['subCategories'] as $key=>$value)
                {
                    $dataView['subCategoriesAr'][$key] = $this->loadModel("CategoryArModel")->retriveDataById("id_category",$value['id']);
                    $dataView['subCategoriesEn'][$key] = $this->loadModel("CategoryEnModel")->retriveDataById("id_category",$value['id']);
                }
            }
            
            // get main category brands
            $dataView['brands'] = $this->loadModel("BrandModel")->retrieveAllData("WHERE `id_category` =? AND `status` =? AND `deleted` = ?",array($dataView['offer']['id_category'],1,1));

            if(is_array($dataView['brands']))
            {
                foreach($dataView['brands'] as $key=>$data)
                {
                    $dataView['brandsEn'][$key] =  $this->loadModel("BrandEnModel")->retriveDataById("id_brand",$data['id']);
                    $dataView['brandsAr'][$key] =  $this->loadModel("BrandArModel")->retriveDataById("id_brand",$data['id']);
                }
            }
            
            // get main category attributes
            $dataView['attributes'] = $this->loadModel("CategoryAttributesModel")->retrieveAllData("WHERE `id_category` =? AND `status` =? AND `deleted` = ?",array($dataView['offer']['id_category'],1,1));

            if(is_array($dataView['attributes']))
            {
                foreach($dataView['attributes'] as $key=>$data)
                {
                    $dataView['attributesEn'][$key] =  $this->loadModel("CategoryAttributesEnModel")->retriveDataById("id_category_attributes",$data['id']);
                    $dataView['attributesAr'][$key] =  $this->loadModel("CategoryAttributesArModel")->retriveDataById("id_category_attributes",$data['id']);
                }
            }
            // get offer items
            $dataView['offerItems'] = $this->loadModel("OfferAttributesModel")->retrieveAllData("WHERE `id_offer` =? AND `status` =? AND `deleted` = ?",array($id,1,1));
            if(is_array($dataView['offerItems']))
            {
                foreach($dataView['offerItems'] as $key=>$value)
                {
                   $dataView['itemEnData'][$key] = $this->loadModel("CategoryAttributesEnModel")->retriveDataById("id_category_attributes",$value['id_attribute']); 
                   $dataView['itemArData'][$key] = $this->loadModel("CategoryAttributesArModel")->retriveDataById("id_category_attributes",$value['id_attribute']); 
                }
            }
            // get offer price
            $dataView['offerPrice'] = $this->loadModel("OfferDefaultPriceModel")->retrieveAllData("WHERE `id_offer` =? AND `status` =? AND `deleted` = ? ORDER BY `id` DESC LIMIT 1",array($id,1,1));
            if(is_array($dataView['offerPrice']))
            {
                $dataView['offerDefaultPrice'] = array_shift($dataView['offerPrice']);
            }
            
            // get categories
            $dataView['allCategories'] = $this->loadModel("CategoryModel")->retrieveAllData("WHERE `id_category` IS NULL AND `status` =? AND `deleted` =?",array(1,1));

            if(is_array($dataView['allCategories']))
            {
                foreach($dataView['allCategories'] as $key=>$data)
                {
                    $dataView['allCategoriesEn'][$key] =  $this->loadModel("CategoryEnModel")->retriveDataById("id_category",$data['id']);
                    $dataView['allCategoriesAr'][$key] =  $this->loadModel("CategoryArModel")->retriveDataById("id_category",$data['id']);
                }
            }
            
            if(isset($_POST['edit']))
            {
                                            
                    // preparing validation array
                    $validationArray = array(
                                            
                                                "id_category"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['id_category'])->clear(),
                                                                 "errorName"=>"Main Category",
                                                                 "rules"=>"required|number"
                                                              ),
                                                "id_sub_category"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['id_sub_category'])->clear(),
                                                                 "errorName"=>"Sub Category",
                                                              ),
                                                "title"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['title'])->clear(),
                                                                 "errorName"=>"Product Title",
                                                                 "rules"=>"required|min-length[3]"
                                                              ),
                                                    "slug"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['slug'])->clear(),
                                                                 "errorName"=>"Product Slug",
                                                                 "rules"=>"required|min-length[3]"
                                                              ),
                                                "description"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['description'])->clear(),
                                                                 "errorName"=>"Description",
                                                                 "rules"=>"min-length[5]"
                                                              ),
                                                "keywords"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['keywords'])->clear(),
                                                                 "errorName"=>"keywords",
                                                              ),
                                                "id_brand"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['id_brand'])->clear(),
                                                                 "errorName"=>"Brand",
                                                                 "rules"=>"number"
                                                              ),
                                                "code"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['code'])->clear(),
                                                                 "errorName"=>"code",
                                                              ),
                                                "price"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['price'])->clear(),
                                                                 "errorName"=>"Price",
                                                                 "rules"=>"required"
                                                              ),
                                                "title_ar"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['title_ar'])->clear(),
                                                                 "errorName"=>"عنوان المنتج",
                                                                 "rules"=>"required|min-length[3]"
                                                              ),
                                                    "slug_ar"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['slug_ar'])->clear(),
                                                                 "errorName"=>"مختصر المنتج",
                                                                 "rules"=>"required|min-length[3]"
                                                              ),
                                                "description_ar"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['description_ar'])->clear(),
                                                                 "errorName"=>"الوصف",
                                                                 "rules"=>"min-length[5]"
                                                              ),
                                                "keywords_ar"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['keywords_ar'])->clear(),
                                                                 "errorName"=>"الكلمات الدليلية",
                                                              ),
                                                "status"=>array(
                                                                 "value"=>$this->loadSecurity($_POST['status'])->clear(),
                                                                 "errorName"=>"Status",
                                                                 "rules"=>"required|number"
                                                              ),
												"special"=>array(
                                                                "value"=>$this->loadSecurity($_POST['special'])->clear(),
                                                                "errorName"=>"special Product",
                                                                "rules"=>"number"
												),
												"discount_prec"=>array(
													"value"=>$this->loadSecurity($_POST['discount_prec'])->clear(),
													"errorName"=>"Discount Precentage",

												),



					);
                    // load validation classs and pass validation data
                    $dataValid = $this->loadValidation($validationArray)->formValidate();
                    // check if the data is ok
                    if(is_array($dataValid) && array_key_exists("success",$dataValid))
                    {
                        $productDataModel['id_category'] = $dataValid['success']['id_category'];
                        $productDataModel['id_sub_category'] = $dataValid['success']['id_sub_category'];
                        $productDataModel['id_brand'] = $dataValid['success']['id_brand'];
                        $productDataModel['code'] = $dataValid['success']['code'];
                        $productDataModel['special']=$dataValid['success']['special'];
                        $productDataModel['status'] = $dataValid['success']['status'];
                        $productDataModel['last_updated_by'] = $user_id;

                        // update data
                        $update = $this->loadModel("OfferModel",$productDataModel)->updateData("id",$id);
                        if(FALSE !== $update)
                        {
                            // update data en
                            $offerEnDataModel['title'] = $dataValid['success']['title'];
                            $offerEnDataModel['slug'] = $dataValid['success']['slug'];
                            $offerEnDataModel['description'] = $dataValid['success']['description'];
                            $offerEnDataModel['keywords'] = $dataValid['success']['keywords'];
                            $offerEnDataModel['status'] = $dataValid['success']['status'];
                            $this->loadModel("OfferEnModel",$offerEnDataModel)->updateData("id_offer",$id);
                            // add data ar
                            $offerArDataModel['title'] = $dataValid['success']['title_ar'];
                            $offerArDataModel['slug'] = $dataValid['success']['slug_ar'];
                            $offerArDataModel['description'] = $dataValid['success']['description_ar'];
                            $offerArDataModel['keywords'] = $dataValid['success']['keywords_ar'];
                            $offerArDataModel['status'] = $dataValid['success']['status'];
                            $offerArDataModel['created'] = time();
                            $this->loadModel("OfferArModel",$offerArDataModel)->updateData("id_offer",$id);
                            // update offer report
                            $offerReportModel['id_category'] = $dataValid['success']['id_category'];
                            $offerReportModel['id_sub_category'] = $dataValid['success']['id_sub_category'];
                            $updateReport = $this->loadModel("OfferReportModel",$offerReportModel)->updateData("id_offer",$id);
                            // update data to offer price
                           
                                $offerPriceDataModel['id_offer'] = $id;
                                $offerPriceDataModel['id_user'] = $user_id;
                                $offerPriceDataModel['price_per_item'] = $dataValid['success']['price'];
                                $offerPriceDataModel['created'] = time();
                                if($dataValid['success']['discount_prec']==null){
									$offerPriceDataModel['price_after_discount'] = $dataValid['success']['price'];

								}else{
									$descount = ((float)$dataValid['success']['price'] * (float)$dataValid['success']['discount_prec']) / 100 ;
									//start collect all data
									$offerPriceDataModel['price_after_discount'] = $dataValid['success']['price'] - $descount;
							 		$offerPriceDataModel['discount']=$dataValid['success']['discount_prec'];
							 		//var_dump($offerPriceDataModel['discount']);
								}

								$this->loadModel("OfferDefaultPriceModel",$offerPriceDataModel)->add();
                            
                            
                            
                            // start add offrer attributes if found
                            $offerAttributes = $_POST['attr'];
                            $offerAttributesVlues = $_POST['attr_values_en'];
                            $offerAttributesVluesAr = $_POST['attr_values_ar'];
                            if(is_array($offerAttributes))
                            {
                                  foreach($offerAttributes as $key=>$data)
                                 {
                                    if($data != 0 || $offerAttributesVlues[$key] != NULL || $offerAttributesVluesAr[$key] != NULL)
                                    {
                                        $offerAttrsDataModel['id_offer'] = $id;
                                        $offerAttrsDataModel['id_attribute'] = $data;
                                        $offerAttrsDataModel['value'] = $offerAttributesVlues[$key];
                                        $offerAttrsDataModel['value_ar'] = $offerAttributesVluesAr[$key];
                                        $offerAttrsDataModel['created'] = time();
                                        // load Model To Add attrs data
                                        $addOfferAttributes = $this->loadModel("OfferAttributesModel",$offerAttrsDataModel)->add();
                                    }
                                }  
                            }

                            $dataView['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Updated Successfully Please Wait .. </div>';
                          header("Refresh: 2");

                        }else{
                            $dataView['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Updating Your Data Please Try Again</div>';
                        }
                        
                    }else{
                        $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                    }
            }
            
            // set page title
			$dataView['title'] = "Edit Product Information";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
          //  $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."offer_edit_selected";
			$TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "offer" . DIRECTORY_SEPARATOR . "offer_edit_selected";


			// load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
       
        public function show_selected()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            // get id from url
            $id = (int)$this->loadRoute()->getSegment(2);
            if($id == 0)
            {
                $this->redirect("Errors","index");
                exit();
            }
            // get trip data
            $dataView['offer'] = $this->loadModel("OfferModel")->retrieveAllData("WHERE `id` =? AND `deleted` =?",array($id,1));
            if(!is_array($dataView['offer']))
            {
                $this->redirect("Errors","index");
                exit();
            }
            $dataView['offer'] = array_shift($dataView['offer']);
            // offer lang data
            $dataView['offerEnData'] = $this->loadModel("OfferEnModel")->retriveDataById("id_offer",$id);
            $dataView['offerArData'] = $this->loadModel("OfferArModel")->retriveDataById("id_offer",$id);
            // get offer summery
            $dataView['offerSummery'] = $this->loadModel("OfferReportModel")->retriveDataById("id_offer",$id);
            // get offer images	
            $dataView['offerImages'] = $this->loadModel("OfferImagesModel")->retrieveAllData("WHERE `id_offer` =? AND `status` =? AND `deleted` = ?",array($id,1,1));

            // get offer category and sub category
            $dataView['offerEnCategory'] = $this->loadModel("CategoryEnModel")->retriveDataById("id_category",$dataView['offer']['id_category']);
            $dataView['offerArCategory'] = $this->loadModel("CategoryArModel")->retriveDataById("id_category",$dataView['offer']['id_category']);
            $dataView['offerEnSubCategory'] = $this->loadModel("CategoryEnModel")->retriveDataById("id_category",$dataView['offer']['id_sub_category']);
            $dataView['offerArSubCategory'] = $this->loadModel("CategoryArModel")->retriveDataById("id_category",$dataView['offer']['id_sub_category']);

            // get offer items
            $dataView['offerItems'] = $this->loadModel("OfferAttributesModel")->retrieveAllData("WHERE `id_offer` =? AND `status` =? AND `deleted` = ?",array($id,1,1));
            if(is_array($dataView['offerItems']))
            {
                foreach($dataView['offerItems'] as $key=>$value)
                {
                   $dataView['itemEnData'][$key] = $this->loadModel("CategoryAttributesEnModel")->retriveDataById("id_category_attributes",$value['id_attribute']); 
                   $dataView['itemArData'][$key] = $this->loadModel("CategoryAttributesArModel")->retriveDataById("id_category_attributes",$value['id_attribute']); 
                }
            }
            // get offer price
            $dataView['offerPrice'] = $this->loadModel("OfferDefaultPriceModel")->retrieveAllData("WHERE `id_offer` =? AND `status` =? AND `deleted` = ? ORDER BY `id` DESC LIMIT 1",array($id,1,1));
            if(is_array($dataView['offerPrice']))
            {
                $dataView['offerDefaultPrice'] = array_shift($dataView['offerPrice']);
            }
            // get offer user
            $dataView['addedBy'] = $this->loadModel("UserModel")->retriveDataById("id",$dataView['offer']['created_by']); 
            $dataView['lastUpdatedBy'] = $this->loadModel("UserModel")->retriveDataById("id",$dataView['offer']['last_updated_by']); 
            
            // set page title
			$dataView['title'] = "Show Offer Information";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
			$TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "offer" . DIRECTORY_SEPARATOR . "offer_show_selected";

			// load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }

        public function edit_images()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            // get id from url
            $id = (int)$this->loadRoute()->getSegment(2);
            if($id == 0)
            {
                $this->redirect("Errors","index");
                exit();
            }
            // get trip data
            $dataView['offer'] = $this->loadModel("OfferModel")->retrieveAllData("WHERE `id` =? AND `deleted` =?",array($id,1));
            if(!is_array($dataView['offer']))
            {
                $this->redirect("Errors","index");
                exit();
            }
            $dataView['offer'] = array_shift($dataView['offer']);
            // get offer summery
            $dataView['offerSummery'] = $this->loadModel("OfferReportModel")->retriveDataById("id_offer",$id);
            // get offer images	
            $dataView['offerImages'] = $this->loadModel("OfferImagesModel")->retrieveAllData("WHERE `id_offer` =? AND `status` =? AND `deleted` = ?",array($id,1,1));

            // set page title
			$dataView['title'] = "Show Product Information";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH."offer_images_edit";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        public function offer_add_more_images()
        {
               $id = (int)$_POST['id_offer'];
               if($id == 0)
               {
                   echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                   exit;
               }
                // upload images
               $upload = $this->loadUpload("images")->do_upload();
               $counter = 0;
                foreach($upload['uploaded'] as $value)
                {
                    //preparing data to be sent to model
                    $albumImagesData['id_offer'] = $id;
                    $albumImagesData['created'] = time();
                    $albumImagesData['image'] = $value;
                    // load Model To Add Images Name
                    if($this->loadModel("OfferImagesModel",$albumImagesData)->add())
                    {
                       $counter++;
                    }
                }
                if($counter == 0)
                {
                   echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                   exit;
                }else if($counter < count($upload['uploaded'])){
                    echo $this->loadAjax()->DataToJson(array("status"=>"Somefaild"));
                   exit;
                }else{
                     echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                    exit;
                }
        }
        public function delete_offer_images()
	   {
		if(isset($_POST['action'],$_POST['imageId']) && $_POST['action'] == "deleteImage")
        {

            // get image id
            $image_id = (int)$_POST['imageId'];
			
            if($image_id == 0)
            {
                echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                exit;
            }else{

                if(false !== $this->loadModel("OfferImagesModel",array("deleted"=>2))->updateData("id",$image_id))
                {
                     echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                    exit;
                }else{
                    echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                    exit;
                }
            }
        }
	}
        public function update_image()
        {
                //get id
                $id = (int)$_POST['field_id'];
                 if($id == 0)
                {
                    echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                    exit;
                }else{
                        $upload = $this->loadUpload("image_name")->do_upload();
                       // check if there is error on image
                       if(array_key_exists("uploadError",$upload))
                       {
                           echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                            exit;

                       }else{
                           $dataModel['image'] = $upload['uploaded'][0];
                            $dataModel['last_updated_by'] = $this->loadSession()->getSession("user_id");
                           if(false !== $this->loadModel("OfferModel",$dataModel)->updateData("id", $id))
                           {
                               echo $this->loadAjax()->DataToJson(array("status"=>"success","newImage"=>$dataModel['image']));
                                exit; 
                           }else{
                              echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                            exit;
                           }
                       }
                    }  
        }
        public function updateStatus()
        {
                if(isset($_POST['action'],$_POST['id'],$_POST['status']) && $_POST['action'] == "updateStatus")
                {
                    // get User id
                    $id = (int)$_POST['id'];
                    if($id == 0)
                    {
                        $this->redirect("Errors","index");
                        exit;
                    }else{
                        // get current status
                        $currentStatus = $_POST['status'];
                        // if current status = on set it off
                        if($currentStatus == "on")
                        {
                            $setStatus = 2;
                        }else{
                            $setStatus = 1;
                        }
                        $dataModel['status'] = $setStatus;
                        $dataModel['last_updated_by'] = $this->loadSession()->getSession("user_id");
                        if(false !== $this->loadModel("OfferModel",$dataModel)->updateData("id", $id))
                        {
                            $this->loadModel("OfferReportModel",$dataModel)->updateData("id_offer", $id);
                         echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                         exit;
                        }else{
                            echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                            exit;
                        }
                    }
                }
         }
        public function updateApproved()
        {
                if(isset($_POST['action'],$_POST['id'],$_POST['status']) && $_POST['action'] == "updateApproved")
                {
                    // get User id
                    $id = (int)$_POST['id'];
                    if($id == 0)
                    {
                        $this->redirect("Errors","index");
                        exit;
                    }else{
                        // get current status
                        $currentStatus = $_POST['status'];
                        // if current status = on set it off
                        if($currentStatus == "on")
                        {
                            $setStatus = 2;
                        }else{
                            $setStatus = 1;
                        }
                        $dataModel['approved'] = $setStatus;
                        $dataModel['last_updated_by'] = $this->loadSession()->getSession("user_id");
                        if(false !== $this->loadModel("OfferModel",$dataModel)->updateData("id", $id))
                        {
                            $this->loadModel("OfferReportModel",$dataModel)->updateData("id_offer", $id);
                         echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                         exit;
                        }else{
                            echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                            exit;
                        }
                    }
                }
         }
        
        public function delete()
        {
                if(isset($_POST['action'],$_POST['id']) && $_POST['action'] == "deleteData")
                {
                    $id = (int)$_POST['id'];
                    if($id == 0)
                    {
                        $this->redirect("Errors","index");
                        exit;
                    }else{
                        if(FALSE !== $this->loadModel("OfferModel",array("deleted"=>2))->updateData("id",$id))
                        {
                            $this->loadModel("OfferReportModel",array("deleted"=>2))->updateData("id_offer",$id);
                            echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                            exit;
                        }else{
                            echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                            exit;
                        }
                    }
                 }
         }
        public function deleteAttributes()
        {
                if(isset($_POST['action'],$_POST['id']) && $_POST['action'] == "deleteData")
                {
                    $id = (int)$_POST['id'];
                    if($id == 0)
                    {
                        $this->redirect("Errors","index");
                        exit;
                    }else{
                        if(FALSE !== $this->loadModel("OfferAttributesModel",array("deleted"=>2))->updateData("id",$id))
                        {
                            echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                            exit;
                        }else{
                            echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                            exit;
                        }
                    }
                 }
         }
        public function upload_offer_image()
        {

            $upload = $this->loadUpload("offerImage")->do_upload();
           // check if there is error on image
           if(array_key_exists("uploadError",$upload))
           {
               echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                exit;

           }else{
               $dataModel['image'] = $upload['uploaded'][0];
               echo $this->loadAjax()->DataToJson(array("status"=>"success","newImageUrl"=>UPLOAD_LINK.$dataModel['image'],"newImage"=>$dataModel['image']));
               exit; 
           }
        }
        public function get_sub_categories_by_category_id()
        {
           if(isset($_POST['id'],$_POST['action']) && $_POST['action'] = "getCategorySubCategories")
           {
               $id = (int) $_POST['id'];
               if($id == 0)
               {
                 echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                 exit;  
               }

                // get category data
                $dataView['category'] = $this->loadModel("CategoryModel")->retrieveAllData("WHERE `id` =? AND `status` =? AND `deleted` = ?",array($id,1,1));
                if(!is_array($dataView['category']))
                {
                  echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                     exit;  
                }
                $dataView['category'] = array_shift($dataView['category']);

                // get category sub categories
                $dataView['subCategories'] = $this->loadModel("CategoryModel")->retrieveAllData("WHERE `id_category` =? AND `status` =? AND `deleted` = ?",array($id,1,1));

                if(is_array($dataView['subCategories']))
                {
                    foreach($dataView['subCategories'] as $key=>$data)
                    {
                        $dataView['subCategoriesEn'][$key] =  $this->loadModel("CategoryEnModel")->retriveDataById("id_category",$data['id']);
                        $dataView['subCategoriesAr'][$key] =  $this->loadModel("CategoryArModel")->retriveDataById("id_category",$data['id']);
                    }
                }

               // get category attributes
                $dataView['category_attributes'] = $this->loadModel("CategoryAttributesModel")->retrieveAllData("WHERE `id_category` =? AND `status` =? AND `deleted` = ?",array($id,1,1));

                if(is_array($dataView['category_attributes']))
                {
                    foreach($dataView['category_attributes'] as $key=>$data)
                    {
                        $dataView['category_attributes_lang_en'][$key] =  $this->loadModel("CategoryAttributesEnModel")->retriveDataById("id_category_attributes",$data['id']);
                        $dataView['category_attributes_lang_ar'][$key] =  $this->loadModel("CategoryAttributesArModel")->retriveDataById("id_category_attributes",$data['id']);
                    }
                }

               
               // get category brands
                $dataView['category_brands'] = $this->loadModel("BrandModel")->retrieveAllData("WHERE `id_category` =? AND `status` =? AND `deleted` = ?",array($id,1,1));

                if(is_array($dataView['category_brands']))
                {
                    foreach($dataView['category_brands'] as $key=>$data)
                    {
                        $dataView['category_brands_en'][$key] =  $this->loadModel("BrandEnModel")->retriveDataById("id_brand",$data['id']);
                        $dataView['category_brands_ar'][$key] =  $this->loadModel("BrandArModel")->retriveDataById("id_brand",$data['id']);
                    }
                }

                $response['status'] = 'success';
                $response['subCategoriesEn'] = (isset($dataView['subCategoriesEn'])) ? $dataView['subCategoriesEn'] : NULL;
                $response['subCategoriesAr'] = (isset($dataView['subCategoriesAr'])) ? $dataView['subCategoriesAr'] : NULL;
                $response['categoryAttributesEn'] = (isset($dataView['category_attributes_lang_en'])) ? $dataView['category_attributes_lang_en'] : NULL;
                $response['categoryAttributesAr'] = (isset($dataView['category_attributes_lang_ar'])) ? $dataView['category_attributes_lang_ar'] : NULL;
                $response['categoryBrandsEn'] = (isset($dataView['category_brands_en'])) ? $dataView['category_brands_en'] : NULL;
                $response['categoryBrandsAr'] = (isset($dataView['category_brands_ar'])) ? $dataView['category_brands_ar'] : NULL;
                echo $this->loadAjax()->DataToJson($response);
                exit; 


           }
        }
        public function getCategoryAttr()
        {
           if(isset($_POST['id'],$_POST['action']) && $_POST['action'] = "getCategoryAttr")
           {
               $id = (int) $_POST['id'];
               if($id == 0)
               {
                 echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                 exit;  
               }

                // get category data
                $dataView['category'] = $this->loadModel("CategoryModel")->retrieveAllData("WHERE `id` =? AND `status` =? AND `deleted` = ?",array($id,1,1));
                if(!is_array($dataView['category']))
                {
                  echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                     exit;  
                }
                $dataView['category'] = array_shift($dataView['category']);


               // get category attributes
                $dataView['category_attributes'] = $this->loadModel("CategoryAttributesModel")->retrieveAllData("WHERE `id_category` =? AND `status` =? AND `deleted` = ?",array($id,1,1));

                if(is_array($dataView['category_attributes']))
                {
                    foreach($dataView['category_attributes'] as $key=>$data)
                    {
                        $dataView['category_attributes_lang_en'][$key] =  $this->loadModel("CategoryAttributesEnModel")->retriveDataById("id_category_attributes",$data['id']);
                        $dataView['category_attributes_lang_ar'][$key] =  $this->loadModel("CategoryAttributesArModel")->retriveDataById("id_category_attributes",$data['id']);
                    }
                }


                $response['status'] = 'success';
                $response['categoryAttributesEn'] = (isset($dataView['category_attributes_lang_en'])) ? $dataView['category_attributes_lang_en'] : NULL;
                $response['categoryAttributesAr'] = (isset($dataView['category_attributes_lang_ar'])) ? $dataView['category_attributes_lang_ar'] : NULL;
                echo $this->loadAjax()->DataToJson($response);
                exit; 


           }
        }
        public function getCountryGovernates()
        {
           if(isset($_POST['id'],$_POST['action']) && $_POST['action'] = "getCountryGovernates")
           {
               $id = (int) $_POST['id'];
               if($id == 0)
               {
                 echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                 exit;  
               }

                // get governates
                $dataView['governates'] = $this->loadModel("GovernateModel")->retrieveAllData("WHERE `id_country` =? AND `status` =? AND `deleted` = ?",array($id,1,1));

                if(is_array($dataView['governates']))
                {
                    foreach($dataView['governates'] as $key=>$data)
                    {
                        $dataView['governatesLang'][$key] =  $this->loadModel("GovernateEnModel")->retriveDataById("id_governate",$data['id']);
                    }
                }


                $response['status'] = 'success';
                $response['governates'] = (isset($dataView['governatesLang'])) ? $dataView['governatesLang'] : NULL;
                echo $this->loadAjax()->DataToJson($response);
                exit; 


           }
        }
		public function showComments()
		{
			/******** start header code ********/
			if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
			{
				// get user id from session
				$user_id = $this->loadSession()->getSession("user_id");
				// get user data for header
				$dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
				if($dataView['userData'] == NULL)
				{
					$this->redirect("errors","index");
					exit();
				}
			}else{
				$this->redirect("admin","login");
			}

			/******* end header code *******/
			//recive offer id
			$id_offer=(int)$this->loadRoute()->getSegment(2);
			if($id_offer ==0)
			{
				$this->redirect("errors","index");
				exit();
			}
			// check id is valid data
			$dataView['offerData']=$this->loadModel("OfferModel")->retriveDataById('id',$id_offer);
			if($dataView['offerData']==null)
			{
				$this->redirect("errors","index");
				exit();
			}
			$dataView['comments']=$this->loadModel("OfferCommentsModel")->retrieveAllData("WHERE `id_offer`=? AND `deleted`=?",array($id_offer,1));
			if(is_array($dataView['comments']))
			{
				foreach ($dataView['comments'] as $key=>$value):
					//get all data
					$dataView['createdBy'][$key]=$this->loadModel("UserModel")->retriveDataById('id',$value['created_by']);
				endforeach;
			}


			$dataView['title'] = "  show comments";
			// global Template Config
			global $TEMPLATE_BACK_END ;
			// set content
			$TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "offer" . DIRECTORY_SEPARATOR . "offer_comment";

			// load template
			$this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
		}
        
}

?>