<?php
    class Service extends Controller{

        public function add()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/

            
            //start Add Anew servicee
			if(isset($_POST['add']))
            {
                
                // preparing validation array
                $validation_array = array(
                                            "name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['enName'])->clear(),
                                                             "errorName"=>"Service Name",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
                                            "ar_name"=>array(
                                                             "value"=>$this->loadSecurity($_POST['arName'])->clear(),
                                                             "errorName"=>"اسم الخدمه",
                                                             "rules"=>"required|min-length[3]"
                                                          ),
											"description"=>array(
															"value"=>$this->loadSecurity($_POST['en_description'])->clear(),
															"errorName"=>"Service Description",
															"rules"=>"required|min-length[10]"
											),
											"ar_description"=>array(
															"value"=>$this->loadSecurity($_POST['ar_description'])->clear(),
															"errorName"=>"وصف الخدمه",
															"rules"=>"required|min-length[10]"
											),

                                            "status"=>array(
                                                             "value"=>$this->loadSecurity($_POST['status'])->clear(),
                                                             "errorName"=>"Status",
                                                             "rules"=>"number"
                                                          ),
                                  );
                // start validation process
						$dataAfterValidation=$this->loadValidation($validation_array)->formValidate();
						//check data is valid or not
				if(is_array($dataAfterValidation)&&array_key_exists("success",$dataAfterValidation))
				{
					//check if english service name is exist before
					if(TRUE !== $this->loadModel("ServiceEnModel")->CheckExists("WHERE `title` =? AND `deleted`=?",array($dataAfterValidation['success']['name'],1)))
					{
						//check if arabic service name is exist before
						if(TRUE !== $this->loadModel("ServiceArModel")->CheckExists("WHERE `title` =? AND `deleted`=?",array($dataAfterValidation['success']['ar_name'],1)))
						{
							// start upload service image
							$upload=$this->loadUpload("image")->do_upload();
							//check if image uploaded or not
							if(!array_key_exists("uploadError",$upload))
							{
								//start add data
								$dataToModel['image']=$upload['uploaded'][0];
								$dataToModel['created']=time();
								$dataToModel['last_updated_by']=$user_id;
								$dataToModel['created_by']=$user_id;
								$dataToModel['status']=$dataAfterValidation['success']['status'];
								$add=$this->loadModel("ServiceModel",$dataToModel)->add();
								//check if data added or not
								if(false !==$add)
								{
									// start add data in ar model
									$dataArModel['id_service']=$add;
									$dataArModel['title']=$dataAfterValidation['success']['ar_name'];
									$dataArModel['description']=$dataAfterValidation['success']['ar_description'];
									$dataArModel['created']=time();
									$dataArModel['last_updated_by']=$user_id;
									$dataArModel['created_by']=$user_id;
									$dataArModel['status']=$dataAfterValidation['success']['status'];
									$this->loadModel("ServiceArModel",$dataArModel)->add();
									//start add data in english model
									$dataEnModel['id_service']=$add;
									$dataEnModel['title']=$dataAfterValidation['success']['name'];
									$dataEnModel['description']=$dataAfterValidation['success']['description'];
									$dataEnModel['created']=time();
									$dataEnModel['last_updated_by']=$user_id;
									$dataEnModel['created_by']=$user_id;
									$dataEnModel['status']=$dataAfterValidation['success']['status'];
									$englishData=$this->loadModel("ServiceEnModel",$dataEnModel)->add();
									if(false !== $englishData)
									{
										$dataView['message'] = '<div class="alert alert-success" role="alert"><strong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Added Successfully Please Wait .. </div>';
										header("Refresh: 2");
									}else{
										$dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Adding  Data ...</div>';
									}
								}else{
									$dataView['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Adding  Data ...</div>';
								}
							}else{
								$dataView['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> User Profile Image Is Required (Max Image Size 2MB)</div>';
							}
						}else{
							$dataView['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Service Arabic Name Exists Before</div>';
						}
					}else{
						$dataView['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Service English Name Exists Before</div>';
					}
				}else{
					$dataView['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataAfterValidation.'</div>';
				}

            }
            
			$dataView['title'] = "Add a New Service";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
			$TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "services" . DIRECTORY_SEPARATOR . "service___add";

            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
        public function getAll()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            //get all service data
			$dataView['service']=$this->loadModel("ServiceModel")->retrieveAllData("where `deleted`=?",array(1));
			if(is_array($dataView['service']))
			{
				//get all arabic and english data
				foreach ($dataView['service'] as $key=>$value):
					$dataView['serviceAr'][$key]=$this->loadModel("ServiceArModel")->retriveDataById('id_service',$value['id']);
					$dataView['serviceEn'][$key]=$this->loadModel("ServiceEnModel")->retriveDataById('id_service',$value['id']);
					endforeach;
			}
			$dataView['title'] = "Show / Edit Service";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
			$TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "services" . DIRECTORY_SEPARATOR . "service___getall";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
        public function edit_selected()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            // get Service id from url
            $serviceId = (int)$this->loadRoute()->getSegment(2);
            if($serviceId == 0)
            {
                $this->redirect("Errors","index");
                exit();
            }
            //get service data
			$dataView['service']=$this->loadModel("ServiceModel")->retriveDataById('id',$serviceId);
            //check data is valid or not
			if($dataView['service'] == null)
			{
				$this->redirect("Errors","index");
				exit();
			}
            if(is_array($dataView['service']))
			{
				//get Servic Arabic Data and English Data
				$dataView['ArService']=$this->loadModel("ServiceArModel")->retriveDataById('id_service',$dataView['service']['id']);
				$dataView['EnService']=$this->loadModel("ServiceEnModel")->retriveDataById('id_service',$dataView['service']['id']);

			}

            //start edit Service
			if(isset($_POST['Edit']))
            {
				// preparing validation array
				$validation_array = array(
												"name"=>array(
													"value"=>$this->loadSecurity($_POST['enName'])->clear(),
													"errorName"=>"Service Name",
													"rules"=>"required|min-length[3]"
												),
												"ar_name"=>array(
													"value"=>$this->loadSecurity($_POST['arName'])->clear(),
													"errorName"=>"اسم الخدمه",
													"rules"=>"required|min-length[3]"
												),
												"description"=>array(
													"value"=>$this->loadSecurity($_POST['en_description'])->clear(),
													"errorName"=>"Service Description",
													"rules"=>"required|min-length[10]"
												),
												"ar_description"=>array(
													"value"=>$this->loadSecurity($_POST['ar_description'])->clear(),
													"errorName"=>"وصف الخدمه",
													"rules"=>"required|min-length[10]"
												),

												"status"=>array(
													"value"=>$this->loadSecurity($_POST['status'])->clear(),
													"errorName"=>"Status",
													"rules"=>"number"
												),
				);
				// start validation process
				$dataAfterValidation=$this->loadValidation($validation_array)->formValidate();
				//check data is valid or not
				if(is_array($dataAfterValidation)&&array_key_exists("success",$dataAfterValidation))
				{
					//check if english service name is exist before
					if(TRUE !== $this->loadModel("ServiceEnModel")->CheckExists("WHERE `title` =? AND `id`!=?  AND `deleted`=?",array($dataAfterValidation['success']['name'],$serviceId,1)))
					{
						//check if arabic service name is exist before
						if(TRUE !== $this->loadModel("ServiceArModel")->CheckExists("WHERE `title` =? AND `id`!=?  AND `deleted`=?",array($dataAfterValidation['success']['ar_name'],$serviceId,1)))
						{
							//start update arabic date
							$dataArModel['title']=$dataAfterValidation['success']['ar_name'];
							$dataArModel['description']=$dataAfterValidation['success']['ar_description'];
							$dataArModel['last_updated_by']=$user_id;
							$dataArModel['status']=$dataAfterValidation['success']['status'];
							$dataToModel['status']=$dataAfterValidation['success']['status'];
							$this->loadModel("ServiceModel",$dataToModel)->updateData('id',$serviceId);
							$update=$this->loadModel("ServiceArModel",$dataArModel)->updateData('id_service',$serviceId);
							if(false !==$update)
								{
									//start add data in english model
									$dataEnModel['title']=$dataAfterValidation['success']['name'];
									$dataEnModel['description']=$dataAfterValidation['success']['description'];
									$dataEnModel['last_updated_by']=$user_id;
									$dataEnModel['status']=$dataAfterValidation['success']['status'];
									$englishData=$this->loadModel("ServiceEnModel",$dataEnModel)->updateData('id_service',$serviceId);
									if(false !== $englishData)
									{
										$dataView['message'] = '<div class="alert alert-success" role="alert"><strong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Updated Successfully Please Wait .. </div>';
										header("Refresh: 2");
									}else{
										$dataView['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Updating  Data ...</div>';
									}
								}else{
								$dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Updating Your Data </div>';								}
						}else{
							$dataView['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Service Arabic Name Exists Before</div>';
						}
					}else{
						$dataView['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Service English Name Exists Before</div>';
					}
				}else{
					$dataView['message'] = '<div class="alert alert-danger" role="alert"><strong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataAfterValidation.'</div>';
				}
                

            }

            // get all interests
			$dataView['title'] = "Edit Selected Service";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
			$TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "services" . DIRECTORY_SEPARATOR . "service___edit_selected";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
        public function updateStatus()
        {
                if(isset($_POST['action'],$_POST['id'],$_POST['status']) && $_POST['action'] == "updateStatus")
                {
                    // get User id
                    $id = (int)$_POST['id'];
                    if($id == 0)
                    {
                        $this->redirect("Errors","index");
                        exit;
                    }else{
                        // get current status
                        $currentStatus = $_POST['status'];
                        // if current status = on set it off
                        if($currentStatus == "on")
                        {
                            $setStatus = 2;
                        }else{
                            $setStatus = 1;
                        }
                        $dataModel['status'] = $setStatus;

                        if(false !== $this->loadModel("ServiceModel",$dataModel)->updateData("id", $id))
                        {
                            $this->loadModel("ServiceEnModel",$dataModel)->updateData("id_service", $id);
                            $this->loadModel("ServiceArModel",$dataModel)->updateData("id_service", $id);
                            echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                            exit;
                        }else{
                            echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                            exit;
                        }
                    }
                }
         }
		public function update_image()
		{
			//get id
			$id = (int)$_POST['field_id'];
			if($id == 0)
			{
				$this->redirect("Errors","index");
				exit;
			}else{
				$upload = $this->loadUpload("image_name")->do_upload();
				// check if there is error on image
				if(array_key_exists("uploadError",$upload))
				{
					echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
					exit;

				}else{
					// get user id from session
					$last_updated_by = $this->loadSession()->getSession("user_id");
					$dataModel['image'] = $upload['uploaded'][0];
					$dataModel['last_updated_by'] = $last_updated_by;

					if(false !== $this->loadModel("ServiceModel",$dataModel)->updateData("id", $id))
					{
						// update Service table
						echo $this->loadAjax()->DataToJson(array("status"=>"success","newImage"=>$dataModel['image']));
						exit;
					}else{
						echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
						exit;
					}
				}
			}
		}
        public function delete()
        {
                if(isset($_POST['action'],$_POST['id']) && $_POST['action'] == "deleteData")
                {
                	//ger service id
                    $id = (int)$_POST['id'];
                    if($id == 0)
                    {
                        $this->redirect("Errors","index");
                        exit;
                    }else{
                        if(FALSE !== $this->loadModel("ServiceModel",array("deleted"=>2))->updateData("id",$id))
                        {
                            $this->loadModel("ServiceEnModel",array("deleted"=>2))->updateData("id_service",$id);
                            $this->loadModel("ServiceArModel",array("deleted"=>2))->updateData("id_service",$id);
                            echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                            exit;
                        }else{
                            echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                            exit;
                        }
                    }
                 }
         }
        /*JSON FORMAT */
        public function retreive_all_governates_by_country_id()
        {
            if(isset($_POST['country_id'])){
                $country_id =  (int)$_POST['country_id'];
                if($country_id !== 0)
                {
                     $allGovernates = $this->loadModel("GovernateModel")->retrieveAllData("WHERE `id_country` = ? AND `deleted` =? AND `status` =?",array($country_id, 1,1));
                    if(is_array($allGovernates))
                    {
                        foreach($allGovernates as $key=>$value)
                        {
                           $allGovernatesEn[$key] = $this->loadModel("GovernateEnModel")->retriveDataById("id_governate",$value['id']);
                           $allGovernatesAr[$key] = $this->loadModel("GovernateArModel")->retriveDataById("id_governate",$value['id']);
                        }
                        $response['status'] = "success";
                        $response['governates'] = $allGovernates;
                        $response['governatesEn'] = isset($allGovernatesEn) ? $allGovernatesEn : NULL;
                        $response['governatesAr'] = isset($allGovernatesAr) ? $allGovernatesAr : NULL;;
                        echo $this->loadAjax()->DataToJson($response);
                        exit;
                    }else{
                        echo $this->loadAjax()->DataToJson(array("status"=>"null"));
                        exit;   
                    }
                }else{
                    echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                    exit;
                }
            }else{
                echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                exit;
            }
        }
        
    }

?>