<?php
    class Star extends Controller{

        public function getAll()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            
            // get all vendors
            $dataView['star'] =  $this->loadModel("EmployeeModel")->retrieveAllData("WHERE `admin_type_id` =? AND `deleted` =?",array(3,1));
            if(is_array($dataView['star']))
			{
				foreach ($dataView['star'] as $key =>$value):
					$dataView['starDetails'][$key]=$this->loadModel("UserModel")->retriveDataById('id',$value['user_id']);
					endforeach;
			}
			$dataView['title'] = "Show / Edit Star";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
			$TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "star" . DIRECTORY_SEPARATOR . "star__getall";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
        public function edit_selected()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);

				if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            // get id star from url
            $id = (int)$this->loadRoute()->getSegment(2);
            if($id == 0)
            {
                $this->redirect("v","index");
                exit();
            }
            $dataView['user'] = $this->loadModel("UserModel")->retrieveAllData("WHERE `id` =?  AND `deleted` =?",array($id,1));
            if($dataView['user'] == NULL)
            {
                $this->redirect("Errors","index");
                exit();
            }
            $dataView['user'] = array_shift($dataView['user']);

            // get data
            $dataView['star'] = $this->loadModel("EmployeeModel")->retrieveAllData("WHERE `user_id` =? AND `deleted` =?",array($id,1));
            if($dataView['star'] == NULL)
            {
                $this->redirect("Errors","index");
                exit();
            }
            $dataView['star'] = array_shift($dataView['star']);

            //start Edit star
			if(isset($_POST['edit']))
            {
                
                // preparing validation array
                $validationArray = array(
                                            "name"=>array(
                                                "value"=> $this->loadSecurity($_POST['name'])->clear(),
                                                "errorName"=>"Star Name",
                                                "rules"=>"required|min-length[3]|max-length[50]"
                                            ),
                                            "mail"=>array(
                                                "value"=> $this->loadSecurity($_POST['email'])->clear(),
                                                "errorName"=>"Email",
                                                "rules"=>"required|email"
                                            ),
                                            "phone"=>array(
                                                "value"=> $this->loadSecurity($_POST['phone'])->clear(),
                                                "errorName"=>"Phone",
                                                "rules"=>"required"
                                            ),

                                            "city_id"=>array(
                                                "value"=> $this->loadSecurity($_POST['city_id'])->clear(),
                                                "errorName"=>"City",
                                                "rules"=>"required|number"
                                            ),
                                            "address"=>array(
                                                "value"=> $this->loadSecurity($_POST['address'])->clear(),
                                                "errorName"=>"Address",
                                                "rules"=>"required|min-length[3]|max-length[50]"
                                            ),
                                            "gender"=>array(
                                                "value"=> $this->loadSecurity($_POST['gender'])->clear(),
                                                "errorName"=>"Gender",
                                                "rules"=>"required|number"
                                            ),

                                            "ssn"=>array(
                                                "value"=> $this->loadSecurity($_POST['ssn'])->clear(),
                                                "errorName"=>"Ssn",
                                                "rules"=>"required|min-length[3]|max-length[50]"
                                            ),
                                            "snapshot"=>array(
                                                "value"=> $this->loadSecurity($_POST['snapshot'])->clear(),
                                                "errorName"=>"snapshot",
                                            ),
                                            

                                            "status"=>array(
                                                "value"=> $this->loadSecurity($_POST['status'])->clear(),
                                                "errorName"=>"Status",
                                                "rules"=>"required|number"
                                            )
                                  );
                // load validation classs and pass validation data
                $dataValid = $this->loadValidation($validationArray)->formValidate();
                // check if the data is ok
                if(is_array($dataValid) && array_key_exists("success",$dataValid))
                { 
                    //check if Mail exists before
                    if(TRUE !== $this->loadModel("UserModel")->CheckExists("WHERE `mail` =? AND `id`!=? AND `deleted`=?",array($dataValid['success']['mail'],$id,1)))
                    {
                        //check if User phone exists before
                        if(TRUE !== $this->loadModel("UserModel")->CheckExists("WHERE `phone` =? AND `id`!=? AND `deleted`=?",array($dataValid['success']['phone'],$id,1)))
                        {
                            // preparing user model
                            $userModel['name'] = $dataValid['success']['name'];
                            $userModel['phone'] = $dataValid['success']['phone'];
                            $userModel['mail'] = $dataValid['success']['mail'];
                            $userModel['city_id'] = $dataValid['success']['city_id'];
                            $userModel['address'] = $dataValid['success']['address'];
                            $userModel['gender'] = $dataValid['success']['gender'];
                            $userModel['last_updated_by'] = $user_id;
                            $userModel['status'] = $dataValid['success']['status'];
                            // update user 
                            $updateUser = $this->loadModel("UserModel", $userModel)->updateData("id",$id);
                            // call user Model 
                            if(FALSE !== $updateUser)
                            {
                                $employeeModel['ssn'] = $dataValid['success']['ssn'];
                                $employeeModel['snapshot'] = $dataValid['success']['snapshot'];
                                $employeeModel['last_updated_by'] = $user_id;
                                $employeeModel['status'] = $dataValid['success']['status'];
                                // edit employee
                                $updateEmployee = $this->loadModel("EmployeeModel", $employeeModel)->updateData("user_id",$id);
                                if(FALSE !== $updateEmployee)
                                {
                                    $dataView['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Updated Successfully Please Wait .. </div>';
                                    header("Refresh: 2"); 
                                }else{
										$dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Updating Vendor  Data</div>';
                                }
                            }else{
                                $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Updating User Data</div>';
                            }
                        }else{
                            $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> User Phone Exists Before </div>';
                        }
                    }else{
                        $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> User Email Exists Before </div>';
                    }
                }else{
                    $dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                }
            }
            
            // get all countries 
            $dataView["allCountries"] = $this->loadModel("CountryModel")->retrieveAllData("WHERE `deleted` =? AND `status` =?",array(1,1));
            if(is_array($dataView['allCountries']))
            {
                foreach($dataView['allCountries'] as $key=>$value)
                {
                    // get ar and en data
                    $dataView['counteriesEn'][$key] = $this->loadModel("CountryEnModel")->retriveDataById("id_country",$value['id']);
                    $dataView['counteriesAr'][$key] = $this->loadModel("CountryArModel")->retriveDataById("id_country",$value['id']);
                }
            }
            // get all cities 
            $dataView["allCities"] = $this->loadModel("CityModel")->retrieveAllData("WHERE `deleted` =? AND `status` =?",array(1,1));
            if(is_array($dataView["allCities"]))
            {
                foreach($dataView["allCities"] as $key => $city)
                {
                   // get ar and en Data
                    $dataView['citiesEn'][$key] = $this->loadModel("CityEnModel")->retriveDataById("id_city",$city['id']);
                    $dataView['citiesAr'][$key] = $this->loadModel("CityArModel")->retriveDataById("id_city",$city['id']);
                }
            }
            
            // get alladmin Types

            // set page title
			$dataView['title'] = "Edit Selected Star";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "star" . DIRECTORY_SEPARATOR ."star__edit_selected";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }
        
        public function show_selected()
        {
			/******** start header code ********/
            if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
            {
                // get user id from session
                $user_id = $this->loadSession()->getSession("user_id");
                // get user data for header
                $dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
                if($dataView['userData'] == NULL)
                {
                    $this->redirect("Errors","index");
                    exit();
                }
            }else{
                $this->redirect("admin","login");
            }

            /******* end header code *******/
            // get  star id from url
            $id = (int)$this->loadRoute()->getSegment(2);
            if($id == 0)
            {
                $this->redirect("Errors","index");
                exit();
            }
            // get data
            $dataView['user'] = $this->loadModel("UserModel")->retrieveAllData("WHERE `id` =?  AND `deleted` =?",array($id,1));
            if($dataView['user'] == NULL)
            {
                $this->redirect("Errors","index");
                exit();
            }
            $dataView['user'] = array_shift($dataView['user']);
            
            
            $dataView['star'] = $this->loadModel("EmployeeModel")->retrieveAllData("WHERE `user_id` =? AND `deleted` =?",array($id,1));
            if($dataView['star'] == NULL)
            {
                $this->redirect("Errors","index");
                exit();
            }
            $dataView['star'] = array_shift($dataView['star']);

            

            // get employee city
            $dataView['vindorCity'] = $this->loadModel("CityEnModel")->retriveDataById("id_city",$dataView['user']['city_id']);
            
            // get user created by
            $dataView['createdBy'] = $this->loadModel("UserModel")->retriveDataById("id",$dataView['user']['created_by']);
            // get last update by
            $dataView['LastUpdatedBy'] = $this->loadModel("UserModel")->retriveDataById("id",$dataView['user']['last_updated_by']);
            // set page title
			$dataView['title'] = "View Selected Star";
            // global Template Config
            global $TEMPLATE_BACK_END ;
            // set content
            $TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "star" . DIRECTORY_SEPARATOR ."star__show_selected";
            // load template
            $this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
        }


		public function updateStatus()
		{
			if(isset($_POST['action'],$_POST['id'],$_POST['status']) && $_POST['action'] == "updateStatus")
			{
				// get User id
				$id = (int)$_POST['id'];
				if($id == 0)
				{
					$this->redirect("Errors","index");
					exit;
				}else{
					// get current status
					$currentStatus = $_POST['status'];
					// if current status = on set it off
					if($currentStatus == "on")
					{
						$setStatus = 2;
					}else{
						$setStatus = 1;
					}
					$dataModel['status'] = $setStatus;
					$dataModel['last_updated_by'] = $this->loadSession()->getSession("user_id");
					if(false !== $this->loadModel("UserModel",$dataModel)->updateData("id", $id))
					{
						$this->loadModel("EmployeeModel",$dataModel)->updateData("user_id", $id);
						echo $this->loadAjax()->DataToJson(array("status"=>"success"));
						exit;
					}else{
						echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
						exit;
					}
				}
			}
		}
        public function update_image()
        {
                //get id
                $id = (int)$_POST['field_id'];
                 if($id == 0)
                {
                    $this->redirect("Errors","index");
                    exit;
                }else{
                        $upload = $this->loadUpload("image_name")->do_upload();
                       // check if there is error on image
                       if(array_key_exists("uploadError",$upload))
                       {
                           echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                            exit;

                       }else{
                           // get user id from session
                           $last_updated_by = $this->loadSession()->getSession("user_id");
                           $dataModel['photo'] = $upload['uploaded'][0];
                           $dataModel['last_updated_by'] = $last_updated_by;
                           
                           if(false !== $this->loadModel("UserModel",$dataModel)->updateData("id", $id))
                           {
                               // update employee table
                               $this->loadModel("VendorModel",array("last_updated_by"=>$last_updated_by))->updateData("id_user",$id);
                               echo $this->loadAjax()->DataToJson(array("status"=>"success","newImage"=>$dataModel['photo']));
                               exit; 
                           }else{
                              echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                            exit;
                           }
                       }
                    }  
        }
        public function delete()
        {
                if(isset($_POST['action'],$_POST['id']) && $_POST['action'] == "deleteData")
                {
                    $id = (int)$_POST['id'];
                    if($id == 0)
                    {
                        $this->redirect("Errors","index");
                        exit;
                    }else{
                        // get user id from session
                        $last_updated_by = $this->loadSession()->getSession("user_id");
                        if(FALSE !== $this->loadModel("UserModel",array("deleted"=>2,"last_updated_by"=>$last_updated_by))->updateData("id", $id))
                        {
                            // update employee table
                            $this->loadModel("EmployeeModel",array("deleted"=>2,"last_updated_by"=>$last_updated_by))->updateData("user_id",$id);
                            echo $this->loadAjax()->DataToJson(array("status"=>"success"));
                            exit;
                        }else{
                            echo $this->loadAjax()->DataToJson(array("status"=>"faild"));
                            exit;
                        }
                    }
                 }
         }
        public function update_password()
        {
            if(isset($_POST['action']) && $_POST['action'] == 'editPass')
            {
               // preparing validation array
                $validationArray = array(
                                        "user_id"=>array(
                                                             "value"=>$this->loadSecurity($_POST['user_id'])->clear(),
                                                             "errorName"=>"User Id",
                                                             "rules"=>"required|number"
                                                          ),
                                            "password"=>array(
                                                             "value"=>$this->loadSecurity($_POST['password'])->clear(),
                                                             "errorName"=>"New Password",
                                                             "rules"=>"required|min-length[6]|sha1_md5"
                                                          ),
                                            "re_password"=>array(
                                                             "value"=>$this->loadSecurity(sha1(md5($_POST['repassword'])))->clear(),
                                                             "errorName"=>"Re-Password",
                                                             "rules"=>"required|match[password]"
                                                          )
                                  );
                // load validation classs and pass validation data
                $dataValid = $this->loadValidation($validationArray)->formValidate();
                // check if the data is ok
                if(is_array($dataValid) && array_key_exists("success",$dataValid))
                {
                    $user_id = $dataValid['success']['user_id'];
                    // unset old password from success array
                    unset($dataValid['success']['re_password']);
                    unset($dataValid['success']['user_id']);
                    // get user id from session
                    $dataValid['success']['last_updated_by'] = $this->loadSession()->getSession("user_id");
                    if(false !== $this->loadModel("UserModel",$dataValid['success'])->updateData("id",$user_id))
                    {
                        $response['status'] = "success";
                        $response['message'] = '<div class="alert alert-success" role="alert"><staong><i class="fa fa-check" aria-hidden="true"></i> Success </strong> Your Data Updated Successfully. </div>';
                        echo $this->loadAjax()->DataToJson($response);
                        exit;
                    }else{
                        $response['status'] = "faild";
                        $response['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong> Error Updating Your Data</div>';
                        echo $this->loadAjax()->DataToJson($response);
                        exit;
                    }
                    
                }else{
                    $response['status'] = "faild";
                    $response['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataValid.'</div>';
                    echo $this->loadAjax()->DataToJson($response);
                    exit;
                } 
            }
        }
        public function update_ssn_image()
        {
                //get id
                $id = (int)$_POST['field_id'];
                 if($id == 0)
                {
                    echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                    exit;
                }else{
                        $upload = $this->loadUpload("image_name")->do_upload();
                       // check if there is error on image
                       if(array_key_exists("uploadError",$upload))
                       {
                           echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                            exit;

                       }else{
                           $dataModel['ssn_image'] = $upload['uploaded'][0];
                           if(false !== $this->loadModel("EmployeeModel",$dataModel)->updateData("user_id", $id))
                           {
                               echo $this->loadAjax()->DataToJson(array("status"=>"success","newImage"=>$dataModel['ssn_image']));
                                exit; 
                           }else{
                              echo $this->loadAjax()->DataToJson(array("status"=>"falid"));
                             exit;
                           }
                       }
                    }

        }
        public function showMonthlyOrder()
		{
			/******** start header code ********/
			if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
			{
				// get user id from session
				$user_id = $this->loadSession()->getSession("user_id");
				// get user data for header
				$dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
				$dataView['starData'] = $this->loadModel("EmployeeModel")->retriveDataById("user_id",$user_id);
				if($dataView['userData'] == NULL)
				{
					$this->redirect("Errors","index");
					exit();
				}
			}else{
				$this->redirect("admin","login");
			}

			/******* end header code *******/
			//get star id from url
			$id=(int)$this->loadRoute()->getSegment(2);
			if($id==0)
			{
				$this->redirect("Errors","index");
				exit();
			}
			// get validate star data
			$dataView['star']=$this->loadModel("UserModel")->retriveDataById('id',$id);
			$dataView['starReminingData']=$this->loadModel("EmployeeModel")->retriveDataById('user_id',$id);
			if($dataView['star'] == null)
			{
				$this->redirect("error","index");
				exit();

			}
			if($dataView['starReminingData'] == null)
			{
				$this->redirect("Errors","index");
				exit();

			}
			// start collect monthly =>order deliverd to customer
			$month=date('y/m/01');
			$dataView['starMonthlyOrderToCueomer']=$this->loadModel("StarToCustomerModel")->retrieveAllData("WHERE 
			`id_star` =? AND `deleted` =? AND  `created`>=? ",array($id,1,strtotime($month)));
			// start collect data =>order get product from vendor
			$dataView['starMonthlyOredrToVendor']=$this->loadModel("StarToVendorModel")->retrieveAllData("WHERE 
			`id_star` =? AND `deleted` =? AND  `created`>=? ",array($id,1,strtotime($month)));
			//get totalcount of order deliverd to customer
			$dataView['totalCountOfStarMonthlyOrderToCueomer']=count($dataView['starMonthlyOrderToCueomer']);
			// get totalcount deliverd to vendor to get product
			$dataView['totalCountOfstarMonthlyOredrToVendor']=count($dataView['starMonthlyOredrToVendor']);
			//get totalorders
			$dataView['totalOrders']=$dataView['totalCountOfstarMonthlyOredrToVendor']+$dataView['totalCountOfStarMonthlyOrderToCueomer'];
			$dataView['title'] = "Show Monthly Orders";
			// global Template Config
			global $TEMPLATE_BACK_END ;
			// set content
			$TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "star" . DIRECTORY_SEPARATOR ."star_monthly_order";
			// load template
			$this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();

		}
		public function getReport()
		{
			/******** start header code ********/
			if(FALSE !== $this->loadHelper("UserHelper")->check_user_login())
			{
				// get user id from session
				$user_id = $this->loadSession()->getSession("user_id");
				// get user data for header
				$dataView['userData'] = $this->loadModel("UserModel")->retriveDataById("id",$user_id);
				$dataView['starData'] = $this->loadModel("EmployeeModel")->retriveDataById("user_id",$user_id);
				if($dataView['userData'] == NULL)
				{
					$this->redirect("Errors","index");
					exit();
				}
			}else{
				$this->redirect("admin","login");
			}

			/******* end header code *******/
			//get star id from url
			$id=(int)$this->loadRoute()->getSegment(2);
			if($id==0)
			{
				$this->redirect("Errors","index");
				exit();
			}



			if(isset($_POST['search']))
			{
				// prpare adat for validation
				$validation_array = array(
					"date_from"=>array(
						"value"=>$this->loadSecurity($_POST['dateFrom'])->clear(),
						"errorName"=>"Date From",
						"rules"=>"required"
					),
					"date_to"=>array(
						"value"=>$this->loadSecurity($_POST['dateTo'])->clear(),
						"errorName"=>"Date To",
						"rules"=>"required"
					),
				);

				//start validation proccess
				$dataAfterValidation=$this->loadValidation($validation_array)->formValidate();
				// check data valid or not valid
				if(is_array($dataAfterValidation) && array_key_exists("success",$dataAfterValidation))
				{
					// start collect monthly =>order deliverd to customer
					$dataView['starMonthlyOrderToCueomer']=$this->loadModel("StarToCustomerModel")->retrieveAllData("WHERE 
			        `id_star` =? AND `deleted` =? AND  `created` BETWEEN ? AND ?  ",array($id,1,strtotime($dataAfterValidation['success']['date_from']),strtotime($dataAfterValidation['success']['date_to'])));
					// start collect monthly =>order deliverd to vendor
					$dataView['starMonthlyOredrToVendor']=$this->loadModel("StarToVendorModel")->retrieveAllData("WHERE 
			        `id_star` =? AND `deleted` =? AND  `created` BETWEEN ? AND ?  ",array($id,1,strtotime($dataAfterValidation['success']['date_from']),strtotime($dataAfterValidation['success']['date_to'])));
					//get totalcount of order deliverd to customer
					$dataView['totalCountOfStarMonthlyOrderToCueomer']=count($dataView['starMonthlyOrderToCueomer']);
					// get totalcount deliverd to vendor to get product
					$dataView['totalCountOfstarMonthlyOredrToVendor']=count($dataView['starMonthlyOredrToVendor']);
					//get totalorders
					$dataView['totalOrders']=$dataView['totalCountOfstarMonthlyOredrToVendor']+$dataView['totalCountOfStarMonthlyOrderToCueomer'];

				}else{
					$dataView['message'] = '<div class="alert alert-danger" role="alert"><staong><i class="fa fa-times" aria-hidden="true"></i> Error ! </strong>'.$dataAfterValidation.'</div>';
				}
			}
			$dataView['title'] = " Make Star Report";

			// global Template Config
			global $TEMPLATE_BACK_END ;
			// set content
			$TEMPLATE_BACK_END['files']['content'] = BACK_END_CONTROL_PATH . "star" . DIRECTORY_SEPARATOR ."starreport";
			// load template
			$this->loadTemplate($TEMPLATE_BACK_END,$dataView)->render();
		}
        
    }

?>